/*
 *  E-FolioB
 *  Efolio.cpp
 *
 *     Created on: 18/12/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#include "Efolio.h"

namespace std {


// Construtor
Efolio::Efolio() {

}
// Construtor personalizado para o caso de a opo de avaliao ser exame final
Efolio::Efolio( char letra ){
	setLetra(letra);			// Atribui Letra
	setNota(-1);				// Inicializa nota a -1 ( No aplicavel )
	setPeso(-1);				// Inicializa peso a -1 ( No aplicavel )
}

// Construtor personalizado para o caso de a opo ser avaliao contnua
Efolio::Efolio(string linha, char letra) {		// recebe uma string com a parte linha de dados do ficheiro de Estudantes do curso que contm o eFolio

	stringstream ss (linha);			// Inicializa uma stringstream ss com a linha recebida
	string dados;						// string para receber os dados lidos de getline

	setLetra(letra); 					// Define a letra do eFolio

	getline (ss,dados,';');				// L nota do eFolio
	if (dados == "-")					// Caso seja '-'
		setNota(-1);					// No est atribuida nota
	else	setNota(stof(dados));		// Seno atribui nota

	getline (ss,dados,';');				// L peso do eFolio
	if (dados == "-")					// Caso seja'-'
		setPeso(-1);					// No est atribuido peso
	else	setPeso(stof(dados));		// Seno atribui peso

	getline (ss,dados,';');				// Avana uma posio na linha
}


Efolio::~Efolio() {
	// TODO Auto-generated destructor stub
}

// Mtodo que calcula a nota final do eFolio em funo do peso.
float Efolio::calculaNotaFinalEfolio(){
	float notaFinal;
	if (this->nota == -1)							// Caso a nota no exista
		return -1;									// Devolve -1
	notaFinal= (this->nota * this->peso) / 100;		// seno calcula a nota do efolio (nota(%)*peso)/100
	return notaFinal;								// Devolve valor da nota final
}

// Mtodo que devolve o valor para impresso no ecr, criado para que no aparea '-1' e sim '-'
string Efolio::valorImpressaoNotaEfolio(){
	if (this->nota == -1)						    // Caso a nota seja -1 ( no existe )
		return "-";									// Devolve "-"
	else{
		stringstream ss;														// Seno inicializa um stringstream
		ss << fixed << setprecision(precisaoNota) << calculaNotaFinalEfolio();	// coloca o valor de calculaNotaFinalEfolio() com uma preciso fixa pr-definida no header na stringstream ss
		string s = ss.str();													// inicializa a stringstream para uma string s
		return s;																// retorna a string
	}
}

// Mtodo que insere a nota e o peso num eFolio
void Efolio::userSetEfolio(char letra){															// Recebe a letra do eFolio como argumento
	float dados = 0;
	while (1){																					// Ciclo infinito at receber um valor de nota correto;
		if (letra == 'C')																		// No caso de a letra recebida ser o C
			cout << "Para o caso de no existir eFolio C inserir -1 na Nota" << endl;			// Informa o utilizador que se no existir eFolio C pode inserir -1 na Nota
		cout << "Insira a Nota em Percentagem do eFolio " << letra << ":" << endl;				// Pede ao utilizador para inserir a nota em % do eFoio
		dados = getFloatFromUser();																// Recebe um real (float) do input (teclado)
		if ( dados != -1 && ( dados < 0 || dados > 100))										// Valida a nota inserida e informa o utilizador no caso de no ser um valor vlido
			cout << endl << "ERRO: Valor de Nota invlido, insira um valor entre 0 e 100, ou -1 no caso no haver eFolio "<< letra << endl;
		else {
			setNota(dados);																		// caso contrrio inicializa os dados recebidos em nota
			break;																				// sai do ciclo
		}
	}
	while (1){																					// Ciclo infinito at receber um valor de peso da nota correto ou -1;
		if ( getNota()==-1){																	// Caso a nota tenha valor -1
			setPeso(-1);																		// Inicializa o peso com -1
			break;																				// sai do ciclo
		}
		cout << "insira o Peso da Nota do Efolio " << letra << ":" << endl;						// Pede ao utilizador para inserir um valor do peso
		dados = getFloatFromUser();																// Recebe um real (float) do input (teclado)
		if ( dados < 0 || dados >8 )															// Valida o peso inserido e informa o utilizador no caso de no ser um valor vlido
			cout << endl << "ERRO: Valor do peso invlido, insira um valor entre 0 e 8," << endl <<" tenha em conta que a soma dos pesos de todos os eFolios no pode ultrapassar 8" << endl;
		else{																					// caso contrrio
			setPeso(dados);																		// inicializa peso com os dados inseridos
			break;																				// e sai do ciclo
		}
	}
}

} /* namespace std */
