/*
 *  E-FolioB
 *  Efolio.h
 *
 *     Created on: 18/12/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

// Classe dos eFolios que tem como objetos a letra a nota e o peso e os gere

#ifndef EFOLIO_H_
#define EFOLIO_H_

#include <iostream>
#include <string>								// Para manipulao de strings
#include <sstream>								// Para manipulao de stringstreams
#include <iomanip>								// Para manipulao de outputs no ecr
#include "Auxiliar.h"							// Header com as funes auxiliares ao programa

namespace std {

const int precisaoNota = 2;						// Para definir a preciso (casas decimais) com que so imprimidas as notas no ecr

class Efolio {									// Criao da classe Efolio
private:
	char letra;									// Recebe a letra do eFolio A,B ou C
	float nota;									// Recebe a nota em percentagem do efolio de 0 a 100 %
	float peso;									// Recebe o peso do eFolio ex: 3.5, 4 ou 5

public:
	Efolio();									// construtor vazio
	Efolio(char);								// construtor personalizado que tem como argumento um char (letra do efolio) para o caso em que a opo de avaliao  exame Final (No tem eFolios)
	Efolio(string,char);						// construtor personalizado  que tem como argumentos uma string (dados referentes a um eFolio e a letra do efolio em questo
	virtual ~Efolio();							// Destrutor

	// MTODOS
	// Escrita inline
	void setLetra(char l) { letra = l;};
	void setNota(float n) { nota = n;};
	void setPeso(float p) { peso = p;};

	void userSetEfolio(char);					// Mtodo que inicializa os objetos da classe com valores inseridos pelo utilizador, tem como argumento um char que designa a letra do efolio

	//Leitura inline
	char getLetra() { return letra;};
	float getNota() { return nota;};
	float getPeso() { return peso;};

	//Calculo
	float calculaNotaFinalEfolio();				// Mtodo que calcula a nota final do efolio

	// Impresso
	string valorImpressaoNotaEfolio();			// Mtodo que "Normaliza" a impresso das notas dos efolios no ecr

};

} /* namespace std */

#endif /* EFOLIO_H_ */
