/*
 *  eFolioA
 *  Estudantes.cpp
 *
 *     Created on: 24/11/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#include "Estudantes.h"

namespace std {
// Construtor vazio
Estudantes::Estudantes(){

}

// *B Construtor personalizado para preencher dados do Estudante inseridos pelo input do utilizador (teclado) *B
Estudantes::Estudantes(vector<UC> listaUCsCurso, vector<Estudantes> listaEstComp ) {							// tem como argumentos a lista de Ucs do curso e o vetor estudantes
	vector <Estudantes>::iterator it;																			// inicializa um iterador para o vetor Estudantes
	int nAluno;																									// inteiro para receber o nmero de aluno
	string nomeAluno;																							// string para receber o nome do Aluno
	int checkNumAluno;																							// inteiro para controlo de nmero de aluno

	cout << endl << "Insira o nmero de Aluno do Estudante" << endl;											// pede ao utilizador para inserir o nmero do aluno
	while(1){																									// ciclo infinito at break;
		checkNumAluno = 0;																						// inicializa o checknumAluno a zero
		nAluno = getIntFromUser();																				// recebe um inteiro vlido em nAluno
		for (it = listaEstComp.begin(); it !=listaEstComp.end(); it++){											// percorre o vetor estudantes
			if ((*it).getNumAluno() == nAluno)																	// caso j exista este nmero de aluno
				checkNumAluno = 1;																				// checkNumAluno passa a 1
		}
		if ( checkNumAluno == 1)																				// caso checkNumAluno seja um
			cout << "J Existe um aluno com esse nmero de Aluno, por favor insira um nmero diferente" << endl;// Informa o utilizador que j existe um aluno com esse nmero
		else break;																								// caso contrrio no existe e sai do ciclo
	}
	setNumAluno(nAluno);																						// inicializa o nmero de aluno com nAluno
	cout << endl << "Insira o Nome do Estudante" << endl;														// Pede ao utilizador para inserir o nome do aluno
	fflush(stdin);																		// Linha para limpar o buffer stdin de modo a que o getline no interprete o ultimo "enter", parece ser um problema muito recorrente no c++
	getline(cin,nomeAluno);																						// L uma linha do teclado at ser teclado "enter" para cin
	setNome(nomeAluno);																							// inicializa o nome com nomeAluno

	listaUCs.assign(listaUCsCurso.begin(),listaUCsCurso.end());													// Copia a informao toda do vetor listaUCsCurso inicializado ao se escolher o curso para o vetor listaUCs do novo estudante
	// Ficando o novo estudante com todas as unidades curriculares do curso inicializadas com valores -1 e prontas a receber dados
}

//Construtor personalizado para preencher dados do estudante vindos do ficheiro Estudantes
Estudantes::Estudantes(string linha,ifstream &ficheiro){ 	// Recebe uma string com nmero de aluno e Nome separados por ponto e virgula, e atribui os valores aos objetos
	stringstream ss (linha);								// Cria uma stringstream ss a partir da string recebida no argumento para poder ser usada em getline()
	string dados;											// string para armazenar os dados recebidos de getline()
	// Preenche nmero de aluno e nome do estudante, este construtor pressupe que o ficheiro est na linha ALUNO; e a primeira string ser a imediatamente a seguir a ALUNO;
	getline(ss,dados,';' );
	setNumAluno(stoi(dados));
	getline(ss,dados);
	setNome(dados);
	// Preenche UCs do estudante, supondo que o ficheiro se encontra na primeira linha de UC do estudante
	getline  (ficheiro,dados);								// L uma linha completa do ficheiro
	do{ 													// Preenche
		listaUCs.push_back(UC(dados));						// *B Vetor listaUCs com uma string correspondente aos dados de uma UC
		getline  (ficheiro,dados);							// L prxima linha
	}while (dados.length() > 1);							// Enquanto no encontrar uma linha cujos dados tm um caracter ( linha em branco )
	// END Estudantes
}
// Destruidor
Estudantes::~Estudantes(){

}

// *B Insere nota no eFolio "letra" de uma UC "codigoUC" (seleo da UC) que ir ser facultada pelo utilizador
// Irei apenas comentar um dos Mtodos pois os prximos so idnticos, mudando apenas o mtodo chamado na iterao e um argumento
void Estudantes::userSetNotaEfolioUC( int codigoUC, char letra){					// Recebe como argumentos o cdigo da UC e a letra do eFolio
	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++)					// percorre o vetor das UCs
		if((*itUC).getCodigo() == codigoUC )										// quando encontrar a UC com o cdigo pretendido
			(*itUC).userSetNotaEfolio(letra);										// chama o mtodo userSetNotaEfolio da letra pretendida na iterao do vetor da UC encontrada
}

// *B Insere a nota da provaFinal ( pFolio ou Exame final conforme a Opo de Avaliao )de uma UC "codigoUC" que ir ser facultada pelo utilizador
void Estudantes::userSetNotaProvaFinalUC( int codigoUC){
	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++)
		if((*itUC).getCodigo() == codigoUC )
			(*itUC).userSetNotaProvaFinal();
}

// *B Insere a nota do exame de Recurso ( pFolio Recurso ou Exame Recurso conforme a Opo de Avaliao ) de uma UC "codigoUC" (seleo da UC) que ir ser facultada pelo utilizador
void Estudantes::userSetExameRecursoUC( int codigoUC){
	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++)
		if((*itUC).getCodigo() == codigoUC )
			(*itUC).userSetNotaExameRecurso();
}

// *B Inicializa a Opo de Avaliao de uma UC "codigoUC" (seleo da UC) mediante a opo do aluno, facultada pelo utilizador
void Estudantes::userSetOpcaoAvaliacaoUC( int codigoUC){
	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++)
			if((*itUC).getCodigo() == codigoUC )
				(*itUC).userSetOpcaoAvaliacao();
}

void Estudantes::imprimeEstudante(){				// Imprime o nmero de aluno e o nome no output
	cout << left << setw(larguraInicial) << setfill(separador) << "";
	cout << left << setw(larguraCodigo) << setfill(separador) << numAluno ;
	cout << left << setw(larguraNome) << setfill(separador) << nome;
	cout << endl;

}
// Imprime a informao correspondente a todas as UCs de um estudante // *B Este mtodo foi atualizado para ter em conta os parmetros do eFolio B
void Estudantes::imprimeInfoEstudante(){

	// Interao com o utilizador
	cout << "ALUNO: " << getNome() << endl;
	cout << "Unidades curriculares onde obteve aprovao" << endl;
	cout << endl;
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'
	cout << left << setw(larguraInicial) << setfill(separador) << "";
	cout << left << setw(larguraNome-1) << setfill(separador) << "UC" ;
	cout << left << setw(larguraEcts-2) << setfill(separador) << "ECTS";
	cout << left << setw(larguraOpcaoAv+3) << setfill(separador) << "Opo Avaliao";
	cout << left << setw(larguraEfolio) << setfill(separador) << "eFA";
	cout << left << setw(larguraEfolio) << setfill(separador) << "eFB";
	cout << left << setw(larguraEfolio-3) << setfill(separador) << "eFC";
	cout << left << setw(larguraExame) << setfill(separador) << "pF/Ex.Final";
	cout << left << setw(larguraExame) << setfill(separador) << "Ex.Recurso";

	cout << left << setw(larguraNota) << setfill(separador) << "Nota Final" << endl;
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'

	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++ ){												// Percorre o vetor <UC>
		(*itUC).imprimeInfoUC();																				// Para cada iterao imprime a informao da UC relativa ao estudante
	}

	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl; // Desenha uma linha com o separador '-'

	imprimeTotalUCs();			// Imprime o total de UCs em que o aluno teve aproveitamento
	imprimeTotalEcts();			// Imprime o total de ECTS em que o aluno teve aproveitamento
	imprimeMedia();				// Imprime a mdia das notas das UC em que o aluno teve aproveitamento
	imprimePercentagemCurso();	// Imprime a Percentagem de ECTS que o aluno j concluiu
// END imprimeInfoEstudante
}

// Imprime a informao correspondente a uma UC de um estudante // *B Este mtodo foi adicionado em sobrecarga para poder imprimir os dados de uma UC do Estudante
void Estudantes::imprimeInfoEstudante(int codigoUC){
	// Interao com o utilizador
	cout << "ALUNO: " << getNome() << endl;
	cout << endl;
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'
	cout << left << setw(larguraInicial) << setfill(separador) << "";
	cout << left << setw(larguraNome-1) << setfill(separador) << "UC" ;
	cout << left << setw(larguraEcts-2) << setfill(separador) << "ECTS";
	cout << left << setw(larguraOpcaoAv+3) << setfill(separador) << "Opo Avaliao";
	cout << left << setw(larguraEfolio) << setfill(separador) << "eFA";
	cout << left << setw(larguraEfolio) << setfill(separador) << "eFB";
	cout << left << setw(larguraEfolio-3) << setfill(separador) << "eFC";
	cout << left << setw(larguraExame) << setfill(separador) << "pF/Ex.Final";
	cout << left << setw(larguraExame) << setfill(separador) << "Ex.Recurso";

	cout << left << setw(larguraNota) << setfill(separador) << "Nota Final" << endl;
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'

	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++ ){				// Percorre o vetor <UC>
			if ((*itUC).getCodigo()==codigoUC)									// Caso seja a UC pretendida
				(*itUC).imprimeInfoUC(1);										// Imprime a informao da UC do estudante, com argumento (1) que imprime sem que este tenha obtido aproveitamento
		}
}
// Imprime o total de UCs em que o aluno teve aproveitamento chamando o metodo calculaTotalUCs()
void Estudantes::imprimeTotalUCs(){
	cout << endl;
	cout << "Total de UC: " << calculaTotalUCs() << endl;
}

// Imprime o total de ECTS em que o aluno teve aproveitamento chamando o metodo calculaTotalEcts()
void Estudantes::imprimeTotalEcts(){
	int totalEcts = calculaTotalEcts();
	cout << endl;
	cout << "Total de ECTS: " << totalEcts << endl;
}

void Estudantes::imprimeMedia(){ // imprime valor da mdia com preciso fixa de 3 casas decimais
	cout << endl;
	cout << "Mdia: "<< fixed << setprecision(precisaoMedia) << calculaMedia() << endl;
}

// Imprime a percentagem de ECTS j concluidos pelo aluno e caso tenha aproveitamento a todas as UC imprime uma mensagem de parabns
void Estudantes::imprimePercentagemCurso() {
	cout << endl;
	cout << "Completou " << fixed << setprecision(1) << calculaPercentagemCurso() << "% dos ECTS do Curso " << endl;
	if (calculaTotalEcts() == 180) {
		cout << endl;
		cout << "		################################################" << endl;
		cout << "		########## PARABENS COMPLETOU O CURSO ##########" << endl;
		cout << "		################################################" << endl;
	}
//END imprimePercentagemCurso
}

// Calcula o Total de ECTS a que o aluno obteve aproveitamento
int Estudantes::calculaTotalEcts(){
	int total=0;
	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++ )  // Percorre o vector <UC>
		if ((*itUC).getNota() >= 9.5)								// Para cada iterao verifica se a nota  superior a 9.5
			total = total + (*itUC).getEcts();						// Se for, soma os ECTS da UC na iterao ao total
	return total;													// retorna o total de ECTS que o aluno j concluiu
}

// Calcula o total de UCs que o aluno j concluiu com aproveitamento
int Estudantes::calculaTotalUCs(){
	float total=0;
	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++ )	// Percorre o vector <UC>
		if ((*itUC).getNota() >= 9.5)								// Para cada iterao verifica se a nota  superior a 9.5
			total++;												// Se for, incrementa o total de UCs
	return total;													// retorna o total de UCs
}

// Calcula a media do aluno 										// *B Como pedido o calculo da mdia foi alterado para ser calculado pelos ECTS
float Estudantes::calculaMedia(){
	float ectsVezesNota=0;											// *B Utilizado para acumular o calculo ECTS X Nota para calculo da mdia
	float totalEcts = calculaTotalEcts() ;							// *B Recebe o Total de ECTS j feitos
	for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++ )	// Percorre o vector <UC>
			if ((*itUC).getNota() >= 9.5)							// Para cada iterao verifica se a nota  superior a 9.5
				ectsVezesNota = ectsVezesNota + ((*itUC).getEcts() * (*itUC).getNota());		// *B Se for, acumula o valor de (ECTS X Nota) em ectsVezesNota
	setMediaAluno(ectsVezesNota/totalEcts);							// *B Atribui a mediaAluno  o valor calculado da mdia (sum(ECTS X Nota)) / (total de ECTS j feitos)
	return (mediaAluno);											// Retorna a media do aluno
}
// Calcula a percentagem de ECTS que o aluno j conluiu
float Estudantes::calculaPercentagemCurso(){
	float totalEcts = calculaTotalEcts();	// float que recebe o total de ECTS concluidos pelo aluno
	return ((totalEcts/180)*100);			// retorna a percentagem de ECTS j concluidos pelo aluno, gostaria de ter o calculo do total de ECTS do curso
}											// mas por falta de tempo j no implementei essa parte

// Metodo para identificar o nmero de alunos aprovados e somar as suas mdias para cada UC. (Fase 3)
void Estudantes::setAprovados(vector<UC> & listaUCsCurso, vector<UC>::iterator & itUCcurso){ //recebe um vetor <UC> da Listacurso ( vetor de UCs do curso ) e o seu iterador como referncia
	for (itUCcurso = listaUCsCurso.begin(); itUCcurso != listaUCsCurso.end(); itUCcurso++){  // Percorre o vetor das UC do curso e para cada UC
		for (itUC = listaUCs.begin(); itUC != listaUCs.end(); itUC++ ){ 					 // Percorre o vetor das UC e para cada iterao (UC)
			if ((*itUCcurso).getCodigo()==(*itUC).getCodigo()){								 // Verifica se o cdigo da iterao da UC do Curso  igual ao da iterao da UC do estudante
				if ((*itUC).getNota()>=9.5){												 // Se for e a nota for superior a 9.5 (aluno teve aproveitamento
					(*itUCcurso).setAlunoAprovado();										 // Incrementa o contador de alunos aprovados da UC de Curso da iterao
					(*itUCcurso).setSomaNotas((*itUC).getNota());							 // Soma ao acumulador somaNotas da iterao de UC de curso a nota da iterao de UC do estudante
				}
			}
		}
	}
// END setAprovados()
}


// *B Mtodo de verificao da opo de Avaliao de uma UC "codigoUC" (seleo da UC)
int Estudantes::checkOpcaoAvaliacaoUC(int codigoUC){
	for (itUC=listaUCs.begin();itUC!=listaUCs.end(); itUC++)				// Percorre o vetor UC
		if ((*itUC).getCodigo()==codigoUC)									// ao encontrar a UC na iterao
			return (*itUC).getOpcaoAvaliacao();								// retorna o valor da opo de Avaliao
	return 2;																// Caso no encontre retorna 2 ( linha sem influncia meramente para retornar algo, no programa nunca chega a acontecer )
}

// *B Mtodo que valida os dados dos eFolios de uma UC "codigoUC" (seleo da UC)
int Estudantes::validaDadosEfoliosUC(int codigoUC){
	int validacao;
	for (itUC=listaUCs.begin();itUC!=listaUCs.end(); itUC++)				// Percorre o vetor UCs
		if ((*itUC).getCodigo()==codigoUC){									// quando encontra a UC pretendida
			if((*itUC).validaDadosEfolios())								// Caso o retorno do mtodo de validao de dados dos Efolios na iterao seja 1
				validacao =1;												// inicializa validacao a 1
			else validacao = 0;												// Caso contrario coloca a 0
		}
	return validacao;														// retorna validacao
}

// *B Mtodo que atualiza a Nota Final de uma UC "codigoUC" (seleo da UC)
void Estudantes::atualizaNotaFinalUC(int codigoUC){
	for (itUC=listaUCs.begin();itUC!=listaUCs.end(); itUC++)				// Percorre o vetor UC
		if ((*itUC).getCodigo()==codigoUC){									// quando encontra a UC pretendida
			(*itUC).atualizaNotaFinal();									// Chama o metodo atualizaNotaFinal na iterao do vetor UC
		}
}

// *B Mtodo que gere a gravao dos dados de cada UC no ficheiro
void Estudantes::gravaFicheiroEstudanteUC(ofstream &ficheiro){				// Recebe como argumento um apontador para um ficheiro aberto como output
	for (itUC=listaUCs.begin();itUC!=listaUCs.end(); itUC++){				// Percorre o vetor UCs
		ficheiro << (*itUC).getCodigo() << ";" << (*itUC).getNome() << ";" << (*itUC).getAno() << ";" << (*itUC).getsemestre() << ";" << (*itUC).getEcts() << ";"; // Insere na linha da UC do ficheiro os dados seguindo a
		ficheiro << "AVALIACAO" << ";" << (*itUC).getOpcaoAvaliacao() << ";";																					   // Regra do ficheiro de Estudantes
		(*itUC).gravaFicheiroEstudanteUCEfolios(ficheiro);																										   // Chama o mtodo responsvel pela parte dos eFolios
		ficheiro << "F" << ";" << (*itUC).getProvaFinal() << ";" << "R" << ";" << (*itUC).getProvaRecurso() << ";" << "N" << ";" << (*itUC).getNota() << '\n';	   // Completa com o resto da informao terminando a linha da UC com '\n'
	}
}
//END namespace
}
