/*
 *  eFolioA
 *  Estudantes.h
 *
 *     Created on: 24/11/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#ifndef ESTUDANTES_H_
#define ESTUDANTES_H_

#include <iostream>
#include <fstream>													// Para manipulao de ficheiros
#include <string>													// Para manipulao de strings
#include <vector>													// Para manipulao de vetores
#include <sstream>													// Para manipulao de stringstreams
#include "UC.h"														// include do header da classe UC


namespace std {

class Estudantes {													// Declarao da classe Estudantes
private:															// Seco privada
	unsigned int numAluno; 											// Nmero de matrcula ou nmero de aluno
	string nome; 													// Nome do aluno
	float mediaAluno;												// *B Mdia do aluno
	vector <UC> listaUCs; 											// Vetor para a Lista de UCs do aluno
	vector <UC>::iterator itUC;										// Declarao do iterador do vetor <UC>
public:																// Seco Pblica
	Estudantes();													// Construtor vazio
	Estudantes(vector<UC>,vector<Estudantes>);
	Estudantes(string,ifstream&);									// Construtor personalizado que recebe uma string e uma referncia para um ficheiro de input
	virtual ~Estudantes();											// Destrutor da classe Estudantes

	// Mtodos de impresso da classe
	void imprimeEstudante();										// Imprime o nmero de aluno e o nome de um estudante no output
	void imprimeInfoEstudante();									// Imprime a informao pedida no enunciado de um aluno
	void imprimeInfoEstudante(int codigoUC);						// *B Imprime a informao de uma UC do estudante
	void imprimeTotalUCs();											// Imprime o total de UC que um aluno teve aproveitamento
	void imprimeTotalEcts();										// Imprime o total de ECTS que um aluno j concluiu
	void imprimeMedia();											// Imprime a mdia total do aluno nas UC que teve aproveitamento
	void imprimePercentagemCurso();									// Imprime a percentagem de ECTS j concluidos pelo aluno e caso tenha aproveitamento a todas as UC imprime uma mensagem de parabens

	// Mtodos de leitura (inline)
	int getNumAluno() { return numAluno; };							// L o nmero de aluno devolve numAluno
	string getNome() { return nome; };								// L o nome do aluno devolve nome

	// Mtodos de escrita
	void setNome(string n) { nome = n; };							// Atribui um argumento string a nome
	void setNumAluno(int na) { numAluno = na; };					// Atribui um argumento int a numAluno
	void setMediaAluno(float m) { mediaAluno = m; };				// Atribui um argumento float a mediaAluno

	// *B Mtodos de inicializao de objetos pelo utilizador input (teclado)
	void userSetNotaEfolioUC(int,char);
	void userSetNotaProvaFinalUC(int);
	void userSetExameRecursoUC(int);
	void userSetOpcaoAvaliacaoUC(int codigoUC);

	// Neste metodo, setAprovados() foi onde senti mais dificuldades pelo que cheguei a concluso que teria de
	// passar como referncia o vetor UC e o seu iterador de modo a poder comparar os vetores
	void setAprovados(vector<UC> & listaUSsCurso, vector<UC>::iterator & itUCcurso); // Metodo para identificar o nmero de alunos aprovados e somar as suas mdias para cada UC.
	// Mtodos de calculo
	int calculaTotalUCs();											// Calcula o total de UCs a que o aluno teve aproveitamento
	int calculaTotalEcts();											// Calcula o total de ECTS a que o aluno teve aproveitamento
	float calculaMedia();											// Calcula a mdia das notas a que o aluno teve aproveitamento
	float calculaPercentagemCurso();								// Calcula a percentagem de ECTS com aproveitamento sendo o total de 180

	// *B Mtodo de verificao da opo de avaliao
	int checkOpcaoAvaliacaoUC(int CodigoUC);

	// *B Mtodo de validao dos dados dos eFolios
	int validaDadosEfoliosUC(int);

	// *B Mtodo que gere a atualizao da Nota final
	void atualizaNotaFinalUC(int);

	// *B Mtodo que gere a gravao para o ficheiro Estudantes da informao (do Estudante e respetivas UCs) do programa
	void gravaFicheiroEstudanteUC(ofstream&);
};
}

#endif /* ESTUDANTES_H_ */
