/*
 *  eFolioA
 *  ListaUCs.cpp
 *
 *     Created on: 25/11/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */


#include "Listacurso.h"


namespace std {

// Construtor vazio
Listacurso::Listacurso(){
}

// Destrutor
Listacurso::~Listacurso (){
}

// Metodo que carrega cria a lista de estudantes recebe como argumentos o cdigo do curso, o nmero de estudantes existentes no ficheiro e a referncia para o prprio ficheiro
void Listacurso::setListaEstudantes( int nCurso, int n , ifstream& ficheiro){
	setCurso(nCurso);														// Inicializa com o cdigo do curso
	this->n = n;															// Inicializa o nmero de Estudantes
	string linha;															// String para manipulao de cada linha
	string dados;															// String para receber os dados lidos de cada linha
	for (int i = 0 ; i < n ; ++i){											// Para o nmero de estudantes
		while ( getline( ficheiro,linha) ){									// Enquanto existirem linhas por ler no ficheiro l a linha para a string linha
			stringstream ss (linha);										// Cria uma stringstream ss da linha lida
			getline (ss,dados,';');											// L a linha at um atingir um ';' e retorna a string para dados
			if (dados == "ALUNO") {											// Se a string lida for ALUNO carrega todas as informaes desse aluno
				while (getline(ss,dados)){									// Enquanto existirem linhas por ler l, se for o caso l o resto da linha ( a seguir a ALUNO )para dados
					listaEstudantes.push_back(Estudantes(dados,ficheiro));  // Carrega o vetor <Estudantes> listaEstudantes com a classe Estudantes passando a linha lida e o ficheiro aberto
				}
			}
		}
	}
// END setListaEstudantes
}

// Metodo para carregar os dados das UC na lista de Ucs do curso, recebe como argumentos o cdigo do curso o nmero de UCs
void Listacurso::setUCsCurso(int nCurso,int nUCs,ifstream& ficheiro ){			// e a referncia para o ficheiro que contm as Ucs do curso
	setCurso(nCurso);															// Inicializa com o cdigo do curso
	string dados;																// String para receber os dados lidos
	getline( ficheiro, dados);
		while ( getline( ficheiro,dados) ){										// Enquanto existirem l uma linha do ficheiro
			listaUCsCurso.push_back(UC(dados));							// cria uma lista com as UC do curso no vector listaUCcurso
		}
}

// *B Mtodo que imprime os cursos disponiveis no sistema
void Listacurso::imprimeCursosDisponiveis(){

	cout <<endl;
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;
	cout << left << setw(larguraInicial) << setfill(separador) << "";				// cria espao em branco inicial
	cout << left << setw(larguraCodigo) << setfill(separador) << "Cdigo";			// imprime o Codigo do curso
	cout << left << setw(larguraNome) << setfill(separador) << "Nome do Curso";			// imprime nome do curso
	cout << left << setw(larguraFicheiro) << setfill(separador) << "Ficheiro" << endl;	// imprime o nome do ficheiro
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;

	for ( itMenu = menu.begin(); itMenu != menu.end() ; itMenu++ )					// percorre o vetor menu
		(*itMenu).imprimeCurso();													// para cada iterao imprime o curso

	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;
	cout <<endl;
//END imprimeCursosDisponiveis
}

// *B Metodo para imprimir o curso escolhido
void Listacurso::imprimeCursoEscolhido( int ncurso ){								// Recebe o cdigo do curso
	for ( itMenu = menu.begin(); itMenu != menu.end() ; itMenu++ ){					// percorre o vetor menu
			if((*itMenu).getCodigo()==ncurso)										// quando encontra o curso pretendido
				(*itMenu).imprimeCurso();											// imprime a sua informao na iterao
		}
}

// Metodo para imprimir os estudantes disponveis no sistema
void Listacurso::imprimeEstudantesDisponiveis(){
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'
	cout << left << setw(larguraInicial) << setfill(separador) << "";
	cout << left << setw(larguraCodigo) << setfill(separador) << "N de Aluno" ;
	cout << left << setw(larguraEcts) << setfill(separador) << "Nome do Aluno";
	cout << endl;
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'

	for (it = listaEstudantes.begin(); it != listaEstudantes.end(); it++ )      // Percorre o vetor atravs do iterador
		(*it).imprimeEstudante();	                                            // Imprime informao do estudante para o utilizador poder escolher qual o estudante que pretende consultar

	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'
	cout << endl;
}

// Metodo para imprimir a informao do estudante pretendida pelo enunciado, recebe como argumento o nmero de aluno
void Listacurso::imprimeInfoEstudantes(int n){
	for (it = listaEstudantes.begin(); it != listaEstudantes.end(); it++){      // Percorre a lista de estudantes
		if ((*it).getNumAluno() == n)											// Compara se o nmero de aluno  o pretendido
			(*it).imprimeInfoEstudante();										// Imprime a informao do estudante
	}
}

void Listacurso::imprimeInfoEstudantes(int n, int codigoUC){
	for (it = listaEstudantes.begin(); it != listaEstudantes.end(); it++){      // Percorre a lista de estudantes
		if ((*it).getNumAluno() == n)											// Compara se o nmero de aluno  o pretendido
			(*it).imprimeInfoEstudante(codigoUC);										// Imprime a informao do estudante
	}
}


// Imprime a Informao, cdigo e nome de Todas as UCs para o utilizador poder consultar
void Listacurso::imprimeInfoUCs(){
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'
	cout << left << setw(larguraInicial) << setfill(separador) << "";
	cout << left << setw(larguraCodigo) << setfill(separador) << "Cdigo" ;
	cout << left << setw(larguraEcts) << setfill(separador) << "Nome da Unidade Curricular";
	cout << endl;
	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'

	for (itUCcurso = listaUCsCurso.begin(); itUCcurso != listaUCsCurso.end(); itUCcurso++)
		(*itUCcurso).imprimeUCcodigoNome();

	cout << left << setw(larguraLinha) << setfill(linha) << "" << endl;	// Desenha uma linha com o separador '-'
}

// Imprime as informaes de uma UC seleccionada pelo utilizador atravs do cdigo que vem como argumento
void Listacurso::imprimeInfoUCcurso(int codigo){
	for (itUCcurso = listaUCsCurso.begin(); itUCcurso != listaUCsCurso.end(); itUCcurso++){
			if((*itUCcurso).getCodigo() == codigo)
				(*itUCcurso).imprimeInfoUCcurso();

			}
}

//	Imprime a informao de todas as UCs do curso aps o utilizador ter optado por essa opo
void Listacurso::imprimeInfoTodasUCscurso(){
	for (itUCcurso = listaUCsCurso.begin(); itUCcurso != listaUCsCurso.end(); itUCcurso++)
		(*itUCcurso).imprimeInfoUCcurso();
	}

// Metodo que inicia o processo de contagem de alunos aprovados e soma das notas
void Listacurso::setInfoUCsCurso(vector<Estudantes> listaEstudantes){      // Recebe um vetor <Estudantes>
	itUCcurso = listaUCsCurso.begin();									   // Aponta o iterador para o inicio do vetor de UCs de curso ( primeira UC )
	for (it = listaEstudantes.begin();it != listaEstudantes.end(); it++){  // Percorre cada estudante na lista
		(*it).setAprovados(listaUCsCurso,itUCcurso);					   // Para cada estudante recolhe informao sobre nmero se o aluno foi aprovado e sobre a nota
	}
}

// *B Mtodo que inicia a criao de um novo estudante
void Listacurso::userSetEstudante(vector<UC> listaUnidadesCurso, vector<Estudantes> listaEstComp){	// Recebe dois vetores, a lista de UCs do curso (Ficheiro de Curso) e o vetor Estudantes (onde vai ser inserido o estudante)
	listaEstudantes.push_back(Estudantes(listaUnidadesCurso,listaEstComp));							// d push_back (cria uma nova posio no vetor ) para um novo estudante
}

// *B Metodo que selecciona do vetor listaEstudantes o estudante escolhido para inserir a nota do efolio
void Listacurso::userSetNotaEfolioUCEstudante(int nAluno, int codigoUC, char letra){
	for ( it = listaEstudantes.begin(); it!=listaEstudantes.end() ; it++ )
		if((*it).getNumAluno() == nAluno)
			(*it).userSetNotaEfolioUC(codigoUC,letra);
}

// *B Metodo que selecciona do vetor listaEstudantes o estudante escolhido para inserir a nota da provaFinal seja pfolio ou ExameFinal
void Listacurso::userSetNotaProvaFinalUCEstudante(int nAluno, int codigoUC){
	for ( it = listaEstudantes.begin(); it!=listaEstudantes.end() ; it++ )
		if((*it).getNumAluno() == nAluno)
			(*it).userSetNotaProvaFinalUC(codigoUC);
}

// *B Metodo que selecciona do vetor listaEstudantes o estudante escolhido para inserir a nota do Exame de Recurso
void Listacurso::userSetNotaExameRecursoUCEstudante(int nAluno, int codigoUC){
	for ( it = listaEstudantes.begin(); it!=listaEstudantes.end() ; it++ )
		if((*it).getNumAluno() == nAluno)
			(*it).userSetExameRecursoUC(codigoUC);
}

//*B Metodo que inicializa a opo de avaliao de uma UC de um Estudante
void Listacurso::userSetOpcaoAvaliacaoUCEstudante( int nAluno, int codigoUC){
	for ( it = listaEstudantes.begin(); it!=listaEstudantes.end() ; it++ )
		if((*it).getNumAluno() == nAluno)
			(*it).userSetOpcaoAvaliacaoUC(codigoUC);
}

// Metodo que verifica se o nmero de estudante existe na lista
int Listacurso::checkNumAluno(int numAluno){
	for (it = listaEstudantes.begin(); it != listaEstudantes.end(); it++ ) // Percorre a lista
		if ((*it).getNumAluno() == numAluno)							   // caso o nmero de aluno exista
			return 1;													   // Retorna 1
	return 0;															   // Seno retorna 0
}

// Metodo que verifica se o nmero de estudante existe na lista
int Listacurso::checkCodigoUCcurso(int codigoUC){
	for (itUCcurso = listaUCsCurso.begin(); itUCcurso != listaUCsCurso.end(); itUCcurso++ ) 	// Percorre a lista
		if ((*itUCcurso).getCodigo() == codigoUC)							  				  	// caso o cdigo da UC exista
			return 1;													   					 	// Retorna 1
	return 0;															  					 	// Seno retorna 0
}

// *B Metodo que verifica se o nmero do curso existe
int Listacurso::checkCodigoCurso(int codigoCurso){
	for ( itMenu = menu.begin(); itMenu != menu.end() ; itMenu++ )
		if ((*itMenu).getCodigo() == codigoCurso )
			return 1;
	return 0;
}

// *B Metodo que verifica a Opo de Avaliao numa UC do estudante
int Listacurso::checkOpcaoAvaliacaoUCEstudante( int nAluno, int codigoUC ){
		for (it = listaEstudantes.begin(); it != listaEstudantes.end();it++)				// Percorre o vetor
			if((*it).getNumAluno() == nAluno){												// Em busca do aluno pretendido, ao encontrar o aluno
				return (*it).checkOpcaoAvaliacaoUC(codigoUC);								// Retorna a opo de avaliao da UC
			}
	return 2;																				// retorna 2 ( ser erro ) no caso de no encontrar validacao
}


// *B Metodo que selecciona do vetor listaEstudantes o estudante escolhido para validacao dos dados dos eFolios
int Listacurso::validaDadosEfoliosUCEstudantes(int nAluno, int codigoUC){				// *B Este mtodo procura validacao
	int validacao = 0;
	for (it = listaEstudantes.begin(); it != listaEstudantes.end();it++)				// Percorre o vetor
		if((*it).getNumAluno() == nAluno){												// Em busca do aluno pretendido, ao encontrar o aluno
			if((*it).validaDadosEfoliosUC(codigoUC))									// Procura na UC escolhida pelos Efolios, caso a validao seja 1
				validacao = 1;															// validacao 1
			else validacao = 0;															// Seno validacao 0
		}
	return validacao;																	// retorna validacao
}

// *B Metodo que selecciona do vetor listaEstudantes o estudante escolhido para atualizao da nota final
void Listacurso::atualizaNotaFinalUCEstudante(int nAluno, int codigoUC){
	for (it = listaEstudantes.begin(); it != listaEstudantes.end();it++)
			if((*it).getNumAluno() == nAluno)
				(*it).atualizaNotaFinalUC(codigoUC);

}

// *B Mtodo que Preenche um vetor com os nomes dos ficheiros relativos a cursos
void Listacurso::listaFicheiros(){
	DIR *diretoria;																	// *B Define d como um apontador para o tipo DIR que representa uma diretoria stream
	char *nomeCompleto,*token;														// *B Apontadores tipo char que iro receber o resultado de strtok																// *B
	string nomeConvertido;
	struct dirent *dir;
	diretoria = opendir(".");														// *B Define a diretoria como a actual

	if (diretoria){
		while ((dir = readdir(diretoria)) != NULL){									// *B Enquanto existirem ficheiros l ficheiro
			nomeCompleto = dir->d_name;												// *B Inicializa com o nome completo do ficheiro ( trata-se de um array char* )
			nomeConvertido = charArrayToString(nomeCompleto);						// *B Converte array char* para string de modo a facilitar a sua utilizao
			token = strtok(dir->d_name,"-");										// *B "parte" o array d_name para token at encontrar um '-'
			token = strtok(NULL,"");												// *B a segunda execuo de strtok l o resto do nome do ficheiro  para token
			if(token!=NULL){														// *B Se no for vazio
				if (strcmp(token,"UC.txt") == 0){									// *B e caso o token seja igual a UC.txt  porque foi detetado um ficheiro de curso (ou seja do tipo "codigoCurso" + "-UC.txt")
					menu.push_back(Cmenu(nomeConvertido));							// *B e coloca a informao do ficheiro no vetor menu aps ser processado pela classe Cmenu
				}
			}
		}
	}
	closedir(diretoria);															//*B  Fecha diretoria
}

// *B Mtodo para gravar toda a informao relevante do programa no ficheiro de Estudantes
void Listacurso::gravaFicheiro( string nomeFicheiro){																			// *B Recebe uma string com o nome do ficheiro de Estudantes do curso
	ofstream ficheiro(nomeFicheiro);																							// *B Inicializa o ficheiro nomeficheiro como output(ofstream)

	for ( it = listaEstudantes.begin() ; it != listaEstudantes.end() ; it++ ){													// *B Percorre a lista de estudantes e para cada estudante
		ficheiro << "ALUNO;" << (*it).getNumAluno()<< ";"<< (*it).getNome() << '\n';											// *B Cria uma linha com ALUNO e nome do aluno
		(*it).gravaFicheiroEstudanteUC(ficheiro);																				// *B Chama o mtodo gravaFicheiroEstudanteUC com o ficheiro aberto como argumento para preencher com os dados das UC
		ficheiro << '\n';																										// *B Termina a linha com '\n'
	}
	ficheiro.close();																											// *B Fecha o ficheiro
	cout << endl <<" ---------- AS ALTERAES FORAM GRAVADAS NO FICHEIRO " << nomeFicheiro << " ----------"<<endl << endl;		// *B Informa o utilizador que os dados foram gravados
}
//// END namespace
}








