/*
 *  eFolioA
 *  ListaUCs.h
 *
 *     Created on: 25/11/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#ifndef LISTACURSO_H_
#define LISTACURSO_H_


#include <vector>
#include <string>
#include "Estudantes.h"
#include "UC.h"
#include "Cmenu.h"
#include <dirent.h>																// *B Para manipulao de diretorias e ficheiros

namespace std {

class Listacurso {																// Declarao da classe Listacurso
private:																		// Seco privada
	int curso;																	// Cdigo do curso
	int n;																		// nmero de UCs do curso
	vector<Estudantes> listaEstudantes;											// Vetor de <Estudantes> para receber a lista de estudantes do curso
	vector<Estudantes>::iterator it;											// iterador do vetor <estudante>
	vector<UC> listaUCsCurso;													// vetor de <UC> para receber as Ucs do curso
	vector<UC>::iterator itUCcurso;												// iterador do vetor <UC>
	vector<Cmenu> menu;															// *B vetor para receber os dados dos cursos
	vector<Cmenu>::iterator itMenu;												// *B iterador do vetor <Cmenu>
public:
	Listacurso();																// Construtor vazio
	virtual ~Listacurso();														// Destrutor

	// Mtodos para impresso no output
	void imprimeCursosDisponiveis();
	void imprimeCursoEscolhido(int ncurso);
	void imprimeEstudantesDisponiveis();										// Imprime os estudantes disponveis (carregados) no sistema
	void imprimeInfoEstudantes(int numAluno);									// Imprime a informao do estudante cujo numAluno recebe como argumento
	void imprimeInfoEstudantes(int numAluno,int codigoUC);						// *B Imprime Informao de uma UC de um Estudante
	void imprimeInfoUCs();														// Imprime para cada UC do curso o seu cdigo e nome para o utilizador poder consultar
	void imprimeInfoUCcurso(int codigoUC);												// Imprime a informao da UC do curso cujo cdigo recebe como argumento
	void imprimeInfoTodasUCscurso();											// Imprime a informao de todas as UCs do curso

	// Mtodos de Acesso
	vector<Estudantes> getCopialistaEstudantes(){ return listaEstudantes ;};	// Cria uma cpia da do vetor lista de estudantes para poder ser acedida por outra classe (Estudantes) de modo a ler as notas dos alunos
	vector<UC> getCopiaListaUCsCurso() { return listaUCsCurso;};				// *B Devolve uma cpia do vetor listaUCsCurso.

	// Mtodos para escrita (inline)
	void setCurso(int c) { curso = c; };										// Atribui o valor c a curso
	void setListaEstudantes(int,int,ifstream&);								    // Metodo que vai criar a lista de estudantes contidas num ficheiro
	void setUCsCurso(int,int,ifstream&);										// Metodo que vai criar a lista de Ucs do Curso contidas num ficheiro
	void setInfoUCsCurso(vector<Estudantes>);									// Metodo que vai preencher a informao na lista UC curso com o nmero de estudantes aprovados e a mdia total de cada UC
																				// recebendo como argumento o vetor <Estudantes> com a lista de estudantes existente

	// *B Mtodos que iniciam o processo de inicializao de valores inseridos pelo utilizador
	void userSetEstudante( vector<UC> , vector<Estudantes>);
	// *B Basicamente servem para seleo no vetor listaEstudantes para depois ser seleccionada a UC na prxima Classe (Estudantes)
	void userSetNotaEfolioUCEstudante(int numAluno,int codigoUC,char letra);
	void userSetNotaProvaFinalUCEstudante(int numAluno,int codigoUC);
	void userSetNotaExameRecursoUCEstudante(int numAluno,int codigoUC);
	void userSetOpcaoAvaliacaoUCEstudante(int numAluno,int codigoUC);

	// *B Metodo de verificao dos dados dos Efolios de um Estudante numa determinada UC
	int validaDadosEfoliosUCEstudantes(int numAluno,int codigoUC);

	// *B Mtodo que atualiza a nota Final de um Estudante numa determinada UC
	void atualizaNotaFinalUCEstudante(int numAluno,int codigoUC);

	// Mtodos de Verificao
	int checkCodigoCurso(int nCurso);													// *B Metodo que verifica se existe um cdigo de curso no sistema
	int checkNumAluno(int numAluno);													// Metodo que verifica se um nmero de aluno existe no sistema
	int checkCodigoUCcurso(int codigoUC);												// Metodo que verifica se um cdigo de UC existe
	int checkOpcaoAvaliacaoUCEstudante(int numAluno,int codigoUC);						// *B Metodo que verifica qual a opo de avaliao de um estudante numa determinada UC

	// Mtodo que inicializa o vetor menu com os dados dos cursos existentes ( ficheiros de curso na diretoria )
	void listaFicheiros();

	// Mtodo que inicia a gravao dos dados do programa no ficheiro estudantes
	void gravaFicheiro(string nomeFicheiro);
};
}

#endif /* LISTAUCS_H_ */
