/*
 *  E-FolioB
 *  NotasUC.cpp
 *
 *     Created on: 18/12/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#include "NotasUC.h"

namespace std {

NotasUC::NotasUC() {
	// TODO Auto-generated constructor stub

}

NotasUC::~NotasUC() {
	// TODO Auto-generated destructor stub
}
	// Mtodos de impresso dos objetos da classe
void NotasUC::imprimeOpcaoAvaliacao(){
	cout << opcaoAvaliacao;
}

void NotasUC::imprimeProvaFinal(){
	cout << provaFinal;
}

void NotasUC::imprimeProvaRecurso(){
	cout << provaRecurso;
}

	// Mtodo que "Normaliza" a opo de avaliao para poder ser impressa no ecr
string NotasUC::opcaoAvaliacaoToString(){
	string opcaoAv;

	switch(this->opcaoAvaliacao){			// Para a Opo de Avaliao
	case -1:								// Caso seja -1
		opcaoAv = "-";						// a string  "-"
		break;
	case 0:									// caso seja 0
		opcaoAv = "Ex.Final";				// a string a ser imprimida  "Ex.Final"
		break;
	case 1:									// caso seja 1
		opcaoAv = "Contnua";				// a string a ser imprimida  "Contnua"
		break;
		}
return opcaoAv;								// Retorna a string a ser imprimida no ecr
}

// Mtodo que normaliza a Nota para poder ser impressa no ecr
string NotasUC::getNotaToString(float nota){					// recebe como argumento a nota
	if (nota == -1)												// caso seja -1
		return "-";												// retorna a string "-"
	else{														// caso contrario
		stringstream ss;										// inicializa um stringstream
		ss << fixed << setprecision(precisaoNotaEx) << nota;	// coloca a nota com preciso fixa definida por precisaoNotaEx em ss
		string s = ss.str();									// transforma a stringstream em string
		return s;												// retorna a string
	}
}

// Mtodo que normaliza a Nota Final para poder ser impressa no ecr, precisamente o mesmo principio que no mtodo anterior
string NotasUC::getNotaFinalToString(float nota){
	if (nota == -1)
		return "-";
	else{
		stringstream ss;
		ss <<  nota;
		string s = ss.str();
		return s;
	}
}


// Mtodo que devolve a nota total dos eFolios
float NotasUC::getNotaTotalEfolios(){
	float notaTotalEfolios=0;															// float para receber o somatrio das notas dos eFolios
	for( iteF = eFolios.begin() ; iteF != eFolios.end() ; iteF++) 						// Percorre o vetor dos eFolios
		if ( (*iteF).getNota() >= 0)													// Se a nota existir (de relembrar que se no existir o valor ser -1)
			notaTotalEfolios = notaTotalEfolios + (*iteF).calculaNotaFinalEfolio();		// ento soma a nota calculada pela (nota(%)*peso)/100 do eFolio da iterao a notaTotalEfolios
	return notaTotalEfolios;															// retorna a soma Total das notas calculadas dos eFolios
}


// Mtodo que devolve o nmero de eFolios com nota
int NotasUC::getNumEfolios(){
	int numEfolios=0;															// Inicializa o contador de eFolios
	for ( iteF = eFolios.begin(); iteF!= eFolios.end(); iteF++)					// Percorre o vetor de Efolios
		if ((*iteF).getNota() >=0 )												// para cada eFolio com nota
			numEfolios++;														// Incrementa o contador
	return numEfolios;															// devolve o nmero de Efolios com nota
}

// Mtodo que inicializa os dados de um eFolio com valores inseridos pelo utilizador
void NotasUC::userSetNotaEfolio(char letra){						// Tem como argumento a letra do eFolio que se pretende manipular
	if (getOpcaoAvaliacao()==-1)									// caso a opo de avaliao seja -1 ( No esteja definida ) pede para definir a opo de avaliao
		userSetOpcaoAvaliacao();									// Chama o mtodo que permite ao utilizador definir a opo de avaliao
	if( getOpcaoAvaliacao() == 1){									// Caso a opo seja 1 ( Avaliao contnua )
	for ( iteF = eFolios.begin(); iteF!= eFolios.end(); iteF++)		// Percorre o vetor eFolios
		if ((*iteF).getLetra()==letra)								// at encontrar o eFoio pretendido (letra)
			(*iteF).userSetEfolio(letra);							// chama o mtodo de inicializao de efolios em que o utilizador insere os dados
	}
	else
		cout << "ATENO: No  possivel inserir notas de eFolio, o aluno optou por Exame Final nesta Unidade Curricular" << endl; // Caso contrario informa o utilizador de que a Opo de Avaliao foi Exame final
																																   // no permitindo a inicializao de valores nos eFolios
}

// Mtodo que inicializa a Nota da prova final com valores inseridos pelo utilizador
void NotasUC::userSetNotaProvaFinal(){
	float notaProvaFinal;
	if (getOpcaoAvaliacao()==-1)									// caso a opo de avaliao seja -1 ( No esteja definida ) pede para definir a opo de avaliao
		userSetOpcaoAvaliacao();									// Chama o mtodo que permite ao utilizador definir a opo de avaliao
	while (1){														// Ciclo infinito at break;
		// ExameFinal
		if(getOpcaoAvaliacao()==0){									// Caso a opo de Avaliao seja 0 - exame Final
			cout << endl;											// informa o utilizador
			cout << "O aluno optou pela avaliao por Exame Final por favor insira o valor da nota do Exame" << endl;
			notaProvaFinal = getFloatFromUser();					// L um float validado do teclado
			setProvaFinal(notaProvaFinal);							// e inicializa a provaFinal() com o valor da nota do Exame Final inserido
			if (validaNotaExameFinal())								// se o valor for vlido
				break;												// sai do ciclo
		}
		// avaliao Contnua
		if(getOpcaoAvaliacao()==1){
			if (getNotaTotalEfolios() < 3.5){						// No caso de o aluno no ter obtido nota mnima nos eFolios no  possivel inserir nota de pFolio e  informa o utilizador
				cout << endl << "ATENO Infelizmente o aluno no atingiu a nota mnima nos eFolios para poder ser admitido ao pFolio " << endl << "No  possivel inserir a nota do pFolio "<< endl;
				break;												// sai do ciclo
			}
			else if (getNumEfolios() < 2 ){							// seno, caso o nmero de efolios avaliados seja menor do que 2, no  possivel inserir nota de pFolio e  informa o utilizador
				cout << endl << "ATENO: O aluno tem que ser avaliado em pelo menos 2 efolios para poder ser admitido no pFolio" << endl;
				break;												// sai do ciclo
			} else{													// seno o aluno foi admitido a pfolio, informa o utilizador e pede para inserir o valor da nota
				cout << "O aluno optou pela avaliao contnua por favor insira o valor da nota do pFolio" << endl;
				notaProvaFinal = getFloatFromUser();				// recebe um float validado do teclado
				setProvaFinal(notaProvaFinal);						// inicializa a prova final com a notaProvaFinal
				if(validaNotaPfolio())								// se for valida a nota do pFolio
					break;											// sai do ciclo
			}
		}
	}
//END userSetNotaProvaFinal
}

// Mtodo que inicializa a Nota da prova de recurso com valores inseridos pelo utilizador
void NotasUC::userSetNotaExameRecurso(){
	float notaExameRecurso;
	if(getOpcaoAvaliacao()==-1)														// caso a opo de avaliao seja -1 ( No esteja definida ) pede para definir a opo de avaliao
		userSetOpcaoAvaliacao();													// Chama o mtodo que permite ao utilizador definir a opo de avaliao
	while(1){																		// Ciclo infinito at um break;
// Caso a opo de avaliao seja Contnua
		if(getOpcaoAvaliacao()==1){
			if ( getNotaTotalEfolios() < 3.5 ){										// No caso de o aluno no ter obtido nota mnima nos eFolios, no  possivel inserir nota de pFolio de Recurso, informa o utilizador
				cout << endl << "ATENO Infelizmente o aluno no atingiu a nota mnima nos eFolios para poder ser admitido ao pFolio de Recurso" << endl << "Desta forma fica admitido a Exame de Recurso "<< endl;
				cout << "Por favor insira a nota do Exame de Recurso " << endl;
				notaExameRecurso = getFloatFromUser();								// A prova de Recurso passa a valer 100 % da nota e recebe o valor de um float validado inserido pelo utilizador
				setProvaRecurso(notaExameRecurso);									// Inicializa com a nota do exame de recurso
				if (validaNotaRecurso())											// se for vlida a nota como Exame de Recurso
					break;															// termina o ciclo
			}
			else if ( getNumEfolios() < 2 ){										// seno, caso o nmero de efolios avaliados seja menor do que 2, no  possivel inserir nota de pFolio de Recurso e  informa o utilizador
				cout << endl << "ATENO: O aluno tem que ser avaliado em pelo menos 2 efolios para poder ser admitido no pFolio de recurso" << endl << "Desta forma fica admitido a Exame de Recurso "<< endl;
				cout << "Por favor insira a nota do Exame de Recurso " << endl;
				notaExameRecurso = getFloatFromUser();								// A prova de Recurso passa a valer 100 % da nota e recebe o valor de um float validado inserido pelo utilizador
				setProvaRecurso(notaExameRecurso);									// Inicializa com a nota do exame de recurso
				if (validaNotaRecurso())											// se for vlida a nota como Exame de Recurso
					break;															// termina o ciclo

			} else{																	// Caso contrario
				cout << "O aluno optou pela avaliao contnua e obteve os requisitos para ser admitido a pFolio de Recurso, por favor insira o valor da nota do pFolio de Recurso" << endl;
				notaExameRecurso = getFloatFromUser();								// Recebe o valor da nota de recurso do utilizador
				setProvaRecurso(notaExameRecurso);									// inicializa a prova de recurso com o valor lido
				if(validaNotaPfolioRecurso())										// Se for vlida a nota do pFolio de recurso ( Este mtodo tem em conta que a nota mxima do pFolio de recurso tem que estar entre 0 e 12 )
					break;
			}
		}
		else{																		// Caso contrrio a nota da prova de Recurso vale 100%
		cout << "Por favor insira a nota do Exame de Recurso " << endl;				// Pede ao utilizador para inserir um valor
		notaExameRecurso = getFloatFromUser();										// L o valor
		setProvaRecurso(notaExameRecurso);											// insere o valor na Prova de recurso
		if (validaNotaRecurso())													// e caso a nota seja vlida
			break;																	// Termina o ciclo
		}
	}
}

// Mtodo para permitir ao utilizador definir a Opo de Avaliao
void NotasUC::userSetOpcaoAvaliacao(){
	int opcao;
	while(1){																// Ciclo infinito at um break Informa o utilizador das opes
		cout << "Por defeito a Opo de Avaliao definida para as Unidades Curriculares  avaliao continua, deseja continuar ou redefinir a opo para Exame Final?"<< endl;
		cout <<" Continuar com Avaliao Continua - 1"  << endl;
		cout <<" Redefinir para Exame Final - 0" << endl;
		opcao = getIntFromUser();											// L um inteiro vlido do teclado
		if (opcao==0){														// caso a opo seja 0
			setOpcaoAvaliacao(0);											// inicializa a Opo de Avaliao com 0 - Exame Final
			break;															// termina o ciclo
		}
		else if (opcao ==1){												// Seno caso seja 1
			setOpcaoAvaliacao(1);											// inicializa a Opo de Avaliao com 1 - avaliao contnua
			break;															// termina o ciclo
		}
		else	cout << "Opo invlida" << endl;							// Caso contrrio informa o utilizador de que inseriu uma opo invlida e reinicia o ciclo

	}
}

// Mtodo que valida os dados dos eFolios relativamente aos pesos das notas
int NotasUC::validaDadosEfolios(){
	int validacao = 0;
// Caso a opo de avaliao seja avaliao contnua
	if (getOpcaoAvaliacao()==1){
		int pesoTotal=0;																	// Inteiro inicializado a zero para receber o somatrio do peso total dos eFolios
		float pesos[3];																		// Inicializao de um array de inteiros para receber os pesos dos eFolios
		int i=0;																			// Iterador inicializado a zero para o array

		for ( iteF=eFolios.begin(); iteF!= eFolios.end();iteF++){   						// Percorre o vetor dos eFolios
			pesos[i]=(*iteF).getPeso();														// para cada eFolio
			if (pesos[i]==-1)																// se o peso for -1
				pesos[i]=0;																	// Coloca zero na posio do array
			pesoTotal = pesoTotal + pesos[i];												// soma a pesoTotal o peso do eFolio da iterao do vetor
			i++;																			// incrementa o iterador do array dos pesos
		}
		if (pesoTotal != 8){																// caso o somatrio dos pesos seja diferente de 8 informa o utilizador de que as regras no esto a ser cumpridas
			cout << endl << "ERRO: O peso total dos eFolios tem que ser 8, por favor corrija os valores" << endl;
			cout << "Os pesos que esto definidos neste momento so:" << endl;				// Informa o utilizador dos pesos atuais de cada eFolio
			cout << "eFolio A - " << pesos[0] << endl;
			cout << "eFolio B - " << pesos[1] << endl;
			cout << "eFolio C - " << pesos[2] << endl;
			cout << "Total do peso neste momento  " << pesoTotal << endl;					// Informa o utilizador do total de peso atual
			validacao = 0;																	// coloca a validao a zero pois os valores so invlidos
		}
		else{																				// Caso contrario
			cout << "Valores dos eFolios so Vlidos" <<endl;								// Informa que so vlidos
			validacao = 1;																	// Inicializa validacao a 1
		}
	}
	return validacao;																		// Retorna a validao ( 0 invlido e 1 vlido
	//END validaDadosEfolios
}

// Mtodos de Validao de notas

int NotasUC::validaNotaPfolio(){
	if ( getProvaFinal() > 12 || getProvaFinal() < 0){														// Nota do pFolio tem que estar entre 0 e 12
		cout << "ERRO: A nota do pFolio dever estar entre 0 e 12, por favor corrija o valor" << endl;		// Caso contrario d erro
		return 0;																							// e retorna zero
	}
	else {																									// seno
		cout << "Nota do pFolio inserida  vlida" << endl;													// Informa que nota  vlida
		if( getProvaFinal() < 5.5)																			// No caso de ser inferior a 5.5 Informa o aluno no atingiu a nota minima no pFolio
			cout << endl << "ATENO: Infelizmente o aluno no atingiu a nota mnima no pFolio, desta forma a nota do pFolio no ser considerada para a nota final" << endl ;
		return 1;																							// e retorna 1
	}
}

// Igual ao mtodo de cima mas com o texto pFolio de Recurso
int NotasUC::validaNotaPfolioRecurso(){
	if ( getProvaRecurso() > 12 || getProvaRecurso() < 0){
		cout << "ERRO: A nota do pFolio de Recurso dever estar entre 0 e 12, por favor corrija o valor" << endl;
		return 0;
	}
	else {
		cout << "Nota do pFolio inserida  vlida" << endl;
		if( getProvaRecurso() < 5.5)
			cout << endl << "ATENO: Infelizmente o aluno no atingiu a nota mnima no pFolio de Recurso, desta forma a nota do pFolio de Recurso no ser considerada para a nota final" << endl ;
		return 1;
	}
}

int NotasUC::validaNotaExameFinal(){
	if ( getProvaFinal() > 20 || getProvaFinal() < 0){														// Nota do Exame Final tem que estar entre 0 e 20
		cout << "ERRO: A nota do Exame Final dever estar entre 0 e 20, por favor corrija o valor" << endl;	// seno d erro informando o utilizador
		return 0;																							// retorna 0
	}
	else {																									// caso contrrio
		cout << "Nota do Exame Final inserida  vlida" << endl;											// informa o utilizador que a nota vlida
		return 1;																							// retorna 1
	}
}

// Igual ao Mtodo de cima mas com texto para Exame de Recurso
int NotasUC::validaNotaRecurso(){
	if ( getProvaRecurso() > 20 || getProvaRecurso() < 0){

		cout << "ERRO: A nota do Exame de Recurso dever estar entre 0 e 20, por favor corrija o valor" << endl;
		return 0;
	}
	else {
		cout << "Nota do Exame de Recurso inserida  vlida" << endl;
		return 1;
	}
}

// Mtodo para gravar a parte que diz respeito aos eFolios no ficheiro de Estudantes
void NotasUC::gravaFicheiroEstudanteUCEfolios(ofstream &ficheiro){										// Recebe um apontador para um ficheiro aberto
	for ( iteF = eFolios.begin(); iteF != eFolios.end(); iteF++)										// Percorre p vetor eFolios
		ficheiro << (*iteF).getLetra() << ";" << (*iteF).getNota() << ";" << (*iteF).getPeso() << ";" ;	// Para cada eFolio preenche os dados com as regras do ficheiro de Estudantes respeitante a parte de eFolios
	// exemplo no Ficheiro:  A;-1;-1;B;-1;-1;C;-1;-1;
}

} /* namespace std */
