/*
 *  E-FolioB
 *  NotasUC.h
 *
 *     Created on: 18/12/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#ifndef NOTASUC_H_
#define NOTASUC_H_

#include <iostream>
#include <string>													// Para manipulao de strings
#include <vector>													// Para manipulao de vetores
#include <sstream>													// Para manipulao de stringstreams
#include <fstream>
#include <iomanip>
#include <math.h>
#include "Efolio.h"

class  Efolio;														// Instanciamento da classe Efolio

const int precisaoNotaEx = 2;			// Alterar para redefinir a preciso da nota do pFolio/Ex.Final e Exame de recurso
const int precisaoNotaFinal = 0;		// Alterar para redefinir a preciso da nota Final

namespace std {


class NotasUC{
private:
	int opcaoAvaliacao;					//Receber a opo de avaliao que o estudante escolher 0-Exame Final ou 1-Avaliao Continua
	float provaFinal;					// Receber a nota da prova final seja pFolio ou exame Final em funo da escolha do tipo de avaliao
	float provaRecurso;					// Receber a nota do pfolio de recurso, ou exame de recurso em funo da escolha do tipo de avaliao


public:
	NotasUC();							// Construtor vazio
	virtual ~NotasUC();
	vector <Efolio> eFolios;			// Vetor que receber a informao dos efolios realizados caso aplicvel.
	vector <Efolio>::iterator iteF;
	//MTODOS

	// impresso
	void imprimeOpcaoAvaliacao();
	void imprimeProvaFinal();
	void imprimeProvaRecurso();

	// inicializao de objetos (inline)
	void setOpcaoAvaliacao (int o) { opcaoAvaliacao = o; };
	void setProvaFinal(float p) { provaFinal = p;};
	void setProvaRecurso (float r) { provaRecurso = r; };

	// Mtodos para Preenchimento do vetor eFolios em funo do tipo de Opo de avaliao (inline)
	void setEfolios(char letra) { eFolios.push_back(Efolio(letra)); };						//  para o caso de ser Exame Final
	void setEfolios(string dados, char letra) { eFolios.push_back(Efolio(dados,letra)); };  //  para o caso de ser avaliao contnua

	// Mtodos de inicializao de Objetos com valor inserido pelo utilizador (teclado)
	void userSetOpcaoAvaliacao();
	void userSetNotaEfolio(char);
	void userSetNotaProvaFinal();
	void userSetNotaExameRecurso();

	// Mtodos de leitura (inline)
	int getOpcaoAvaliacao() { return opcaoAvaliacao; };
	float getProvaFinal() { return provaFinal; };
	float getProvaRecurso() { return provaRecurso; };

	// Mtodos de Leitura
	float getNotaTotalEfolios();	// devolve a nota total dos eFolios
	int getNumEfolios();			// devolve o nmero de eFolios

	// Mtodos de normalizao de objetos para impresso
	string opcaoAvaliacaoToString(); 		// devolve em string a opo de avaliao em funo do seu valor
	string getNotaToString(float);			// devolve em string a nota em funo do seu valor com uma preciso pr-definida
	string getNotaFinalToString(float);		// devolve em string a nota final em funo do seu valor com uma preciso pr-definida

	// Mtodos de Validao de dados
	int validaDadosEfolios();
	int validaNotaExameFinal();
	int validaNotaPfolio();
	int validaNotaRecurso();
	int validaNotaPfolioRecurso();

	// Mtodos de acesso
	vector<Efolio> getCopiaeFolios() { return eFolios;};			// devolve uma cpia do vetor de efolios
	int acessaOpcaoAvaliacao() const { return opcaoAvaliacao; };	// devolve a Opo de avaliao

	// Mtodo que gere a gravao da parte respeitante aos eFolios no ficheiro de Estudantes
	void gravaFicheiroEstudanteUCEfolios(ofstream&);

};

} /* namespace std */

#endif /* NOTASUC_H_ */
