/*
 *  eFolioA
 *  Ucs.cpp
 *
 *     Created on: 25/11/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#include "UC.h"

namespace std {

// Construtor
UC::UC() {

}

// Construtor personalizado, recebe uma linha e carrega os valores separados por ';'
UC::UC(string linha){				// *B Recebe como argumento uma string que equivale a uma linha do ficheiro de dados .txt e uma tipo que pode ser curso ou estudante
	stringstream ss (linha);			// Cria uma stringstream ss a partir da string recebida de forma a poder ser interpretada pela getline()
	string dados;						// string que ir receber os dados lidos entre os ';'

	getline (ss,dados,';');				// L a stringstream ss at um ';' para a string dados
	setCodigo(stoi(dados));				// Atribui a cdigo os dados lidos convertidos para int por stoi()

	getline (ss,dados,';');				// L a stringstream ss at um ';' para a string dados
	setNome(dados);						// Atribui a nome os dados lidos

	getline (ss,dados,';');				// L a stringstream ss at um ';' para a string dados
	setAno(stoi(dados));				// Atribui a ano os dados lidos convertidos para int por stoi()

	getline (ss,dados,';');				// L a stringstream ss at um ';' para a string dados
	setSemestre(stoi(dados));			// Atribui a semestre os dados lidos convertidos para int por stoi()

	getline (ss,dados,';');				// L a stringstream ss at um ';' para a string dados
	setEcts(stoi(dados));				// Atribui a ects os dados lidos convertidos para int por stoi()

	getline (ss,dados,';');

	// *B Alteraes no ficheiro de dados para contemplar as novas funcionalidades.

	if (dados == "AVALIACAO"){								// 1If Se os dados lidos forem "AVALIACAO"

		getline(ss,dados,';');								// L os dados da opo de avaliao
		if (dados=="-")										// se for inexistente "-" inicializa com -1
			setOpcaoAvaliacao(-1);
			else setOpcaoAvaliacao(stoi(dados));			// Seno inicializa com o valor 0 ou 1

		if (acessaOpcaoAvaliacao() == 0 || acessaOpcaoAvaliacao() == -1){					// 2If No caso de a opo ser Exame final
			setEfolios('A');								// No h notas de eFolios por isso inicializa o vetor com as letras no construtor,
			setEfolios('B');								// Efolio::Efolio( char letra ) as notas e pesos dos efolios com valor -1
			setEfolios('C');								// um exemplo do uso de sobrecarga
			// Posiciona o ficheiro na linha da prova final ( pFolio ou exame normal )
			getline(ss,dados,'F');
			getline(ss,dados,';');
			getline(ss,dados,';');

		}else if (acessaOpcaoAvaliacao() == 1){				// 2Else 3If Caso a opo tenha sido Avaliao Contnua
			//Avana na linha
			getline(ss,dados,'A');
			getline(ss,dados,';');							// Posiciona o ficheiro na nota do primeiro eFolio
			getline(ss,dados,'B');							// L os dados da linha at B ( toda a informao do efolio A exemplo 3.5;4; )

			setEfolios(dados,'A'); 							// inicializa os valores no vetor para o eFolio A
			//Avana na linha
			getline(ss,dados,';');
			getline(ss,dados,'C');							// L os dados da linha at C ( toda a informao do efolio B )

			setEfolios(dados,'B');							// inicializa os valores no vetor para o eFolio B

			getline(ss,dados,';');
			getline(ss,dados,'F');      					// L os dados da linha at F ( toda a informao do efolio C )

			setEfolios(dados,'C'); 							// inicializa os valores no vetor para o Efolio C

			getline(ss,dados,';');
			getline(ss,dados,';');							// L a prxima posio da linha ( nota da prova presencial ( pfolio ou exame final)

		}else 				//	3Else 4If no caso do valor no ser  -1,0 ou 1 Informa o utilizador de que algo est mal
			cout << "Ficheiro apresenta dados incompatveis, opo de avaliao dever ser 0 para Exame Final ou 1 para Avaliao Contnua" << endl;
		// Parte comum a todas as opes de avaliao

		if (dados=="-")										// Caso  a nota no exista ("-") inicializa com -1
			setProvaFinal(-1);
		else setProvaFinal(stof(dados));					// inicializa com a nota da prova final

		getline(ss,dados,'R');								// L os dados da linha at R
		getline(ss,dados,';');								// Avana uma posio
		getline(ss,dados,';');								// L a prxima posio da linha ( nota do pfolio/exame de recurso )

		if (dados=="-")
			setProvaRecurso(-1);
		else setProvaRecurso(stof(dados));					// inicializa com a nota do pfolio/exame de recurso

		getline(ss,dados,'N');								// L os dados da linha at N
		getline(ss,dados,';');								// Avana uma posio
		getline(ss,dados,';');								// L a prxima posio da linha ( nota final da UC )

		if (dados == "-")									// Caso  a nota no exista ("-") inicializa com -1
			setNota(-1);
		else setNota(stof(dados));							// inicializa com a nota final da UC

	}


//END UC personalizado
}

// Destruidor
UC::~UC(){

}

// Imprime no ecr a informao de uma UC relativa ao estudante ( Fase 2 )
void UC::imprimeInfoUC(){
// Constantes utilizadas na formatao do output
	vector<Efolio> listaEfolios = getCopiaeFolios(); 	// *B Inicializao do vetor com a cpia de vetor<Efolio> eFolios devido a ser private
	vector<Efolio>::iterator itCef;						// *B Inicializao do iterador para listaEfolios

	if (getNota()>=9.5){ 							// caso a nota seja superior a 9.5 mostra a informao da UC
		cout << left << setw(larguraInicial) << setfill(separador) << "";				// cria espao em branco inicial
		cout << left << setw(larguraNome) << setfill(separador) << getNome();			// imprime o nome da UC
		cout << left << setw(larguraEcts) << setfill(separador) << getEcts();			// imprime o n de ECTS da UC
		cout << left << setw(larguraOpcaoAv) << setfill(separador) << opcaoAvaliacaoToString(); // *B imprime a opo de avaliao normalizada

		for (itCef = listaEfolios.begin(); itCef != listaEfolios.end() ; itCef++ ){		// *B Percorre o vetor
			cout << left << setw(larguraEfolio) << setfill(separador) << (*itCef).valorImpressaoNotaEfolio() ; // *B imprime os dados ( nota calculada ) de todos os eFolios no ecr
		}

		cout << left << setw(larguraExame) << setfill(separador) << getNotaToString(getProvaFinal()); 	// *B Imprime valor da nota (caso aplicavel) da prova final (pFolio ou Exame normal)
		cout << left << setw(larguraExame) << setfill(separador) << getNotaToString(getProvaRecurso());	// *B Imprime valor da nota da
		cout << left << setw(larguraNota) << setfill(separador) << getNotaFinalToString(getNota()) << endl;	// imprime a nota da ECTS relativa ao aluno
	}
// END	imprimeInfoUC
}

// *B Imprime no ecr a informao de uma UC ( Fase 2 )
void UC::imprimeInfoUC(int flag){
// Constantes utilizadas na formatao do output
	vector<Efolio> listaEfolios = getCopiaeFolios(); 	// *B Inicializao do vetor com a cpia de vetor<Efolio> eFolios devido a ser private
	vector<Efolio>::iterator itCef;						// *B Inicializao do iterador para listaEfolios

	cout << left << setw(larguraInicial) << setfill(separador) << "";				// cria espao em branco inicial
	cout << left << setw(larguraNome) << setfill(separador) << getNome();			// imprime o nome da UC
	cout << left << setw(larguraEcts) << setfill(separador) << getEcts();			// imprime o n de ECTS da UC
	cout << left << setw(larguraOpcaoAv) << setfill(separador) << opcaoAvaliacaoToString(); // *B imprime a opo de avaliao normalizada
	for (itCef = listaEfolios.begin(); itCef != listaEfolios.end() ; itCef++ ){		// *B Percorre o vetor
		cout << left << setw(larguraEfolio) << setfill(separador) << (*itCef).valorImpressaoNotaEfolio() ; // *B imprime os dados ( nota calculada ) de todos os eFolios no ecr
	}
	cout << left << setw(larguraExame) << setfill(separador) << getNotaToString(getProvaFinal()); 	// *B Imprime valor da nota (caso aplicavel) da prova final (pFolio ou Exame normal)
	cout << left << setw(larguraExame) << setfill(separador) << getNotaToString(getProvaRecurso());	// *B Imprime valor da nota da
	cout << left << setw(larguraNota) << setfill(separador) << getNotaFinalToString(getNota()) << endl;	// imprime a nota da ECTS relativa ao aluno
// END	imprimeInfoUC
}

// Imprime no Ecr a informao de uma UC necessria para a seleo da UC por parte do Utilizador ( Fase 3 )
void UC::imprimeUCcodigoNome(){
// O princpio neste caso ao nvel da formatao do output  o mesmo que no mtodo anterior
		cout << left << setw(larguraInicial) << setfill(separador) << "";				// Espao em Branco
		cout << left << setw(larguraCodigo) << setfill(separador) << getCodigo();		// Imprime cdigo da UC
		cout << left << setw(larguraNome) << setfill(separador) << getNome()<< endl;	// Imprime nome da UC
// END	imprimeUCcodigoNome
}

// Imprime a Informao pedido no enunciado para a fase 3
void UC::imprimeInfoUCcurso(){
		float media;																// Para guardar a mdia
		int alunosAprovados = getAlunosAprovados();									// Inicializa o nmero de alunos aprovados em alunosAprovados
		// Formatao bsica
		cout << endl;																				// Linha em branco no output
		cout << "UNIDADE CURRICULAR: " << getNome() << endl;										// Imprime o nome da UC a seguir ao texto UNIDADE CURRICULAR
		cout << "Total de Alunos Aprovados: " << getAlunosAprovados() << endl;						// Imprime o total de alunos aprovados a seguir ao texto Total de Alunos Aprovados
		// Lgica utilizada para prevenir o caso em que no existem alunos aprovados, evitando assim uma indeterminao 0/0
		if (getAlunosAprovados()!=0){																// Caso existam alunos aprovados
			media = (somaNotas/alunosAprovados);													// calcula a mdia
			cout << "Mdia: "<< fixed << setprecision(3) << media << endl;							// Imprime a mdia com uma preciso fixa de 3 casas decimais
		}
		else cout << "No existem alunos aprovados, logo no  possivel calcular a mdia" << endl;  // Caso no existam alunos aprovados informa o utilizador
// END imprimeInfoUCcurso
}

// *B Mtodo que inicializa/atualiza a nota final de uma UC
void UC::atualizaNotaFinal(){															// A estratgia utilizada foi ter uma variavel com a nota atual para comparao com a nota nova ( calculado ou no )
	float notaAtual=getNota();																						// inicializa notaAtual com a nota existente
	float notaNova=0;																								// float para receber a nota nova
// No caso de a opo de Avaliao se tratar de Exame Final
	if ( getOpcaoAvaliacao() == 0 ){
		if ( getProvaRecurso() == -1 )																				// No caso de a nota da prova de recurso ser -1 (no haver)
			notaNova = getProvaFinal();																				// a nota nova vai ser igual a nota da prova final, no caso Exame final
		else if( getProvaRecurso() > getProvaFinal() )																// caso contrrio se a nota do Exame de recurso for superior a do exame final
			notaNova = getProvaRecurso();																			// nota nova igual a nota do exame de recurso
		else notaNova = getProvaFinal();																			// seno  igual a nota do exame final
	}
// No caso de a Opo de Avaliao ser avaliao contnua
	if ( getOpcaoAvaliacao() == 1){
		if ( getNotaTotalEfolios() >= 3.5 && getNumEfolios() > 1 ){													// se a nota total dos efolios for superior a 3.5 (nota mnima) e o nmero de efolio mais que 1 aluno admitido a pFolio
			if ( getProvaFinal() >= 5.5 )																			// se a prova final, no caso pFolio for maior ou igual a 5.5 (nota mnima)
				notaNova = getNotaTotalEfolios() + getProvaFinal();													// ento a nota nova vai ser a nota total dos efolios mais a nota do pfolio
			else if ( getProvaFinal() == -1)																		// se o pFolio no foi inserido, optei por mostrar a nota final com a nota dos eFolios
				notaNova = getNotaTotalEfolios();																	// notaNova igual a nota total dos eFolios
			if (( notaNova < (getProvaRecurso()+getNotaTotalEfolios())) && getProvaRecurso() >= 5.5 )				// no caso de a notaNova ser menor do que a soma do eFolio com a nota do pFolio de Recurso e a nota do Pfolio de Recurso  maior ou igual a 5.5
				notaNova = getNotaTotalEfolios() + getProvaRecurso();												// ento a nota nova passa a ser a soma da nota dos eFolios com a nota do pFolio se Recurso


		}
		else notaNova = getProvaRecurso();																			// Caso contrrio o aluno no foi admitido a pFolio e a nota nova  igual a nota do Exame de Recurso
	}

// Verificao de melhoria de Nota
	if (notaAtual >= 9.5 && notaNova > notaAtual){																		// Caso o aluno tenha obtido aproveitamento e a nota nova seja superior a atual
		cout << endl << "ATENO: A nova nota  superior a nota existente, trata-se de uma melhoria de nota?" << endl;	// Informa o utilizador que se trata de uma melhoria de nota
		cout << "A Atualizar Nota ..." << endl;																			// e informa que atualizou a nota
		setNota((int)round(notaNova));																					// inicializa a nota Final com a notaNova arredondada para inteiro

	} else if (notaNova < notaAtual)																					// seno, se a nota nova for menor que a atual
		cout << endl << "Nota final no atualizada" << endl;				// informa o utilizador que a nota no foi atualizada

	else setNota((int)round(notaNova));																					// Caso contrrio o aluno ainda no tinha obtido aproveitamento na UC e inicializa a Nota final com a nota nova

	if ( notaAtual == -1 )																								// No caso de a Nota final ser -1, ainda no tinha obtido qualquer nota final
		setNota((int)round(notaNova));																					// inicializa com a nota nova

	cout << endl << endl;
}

//END namespace
}





