/*
 *  eFolioA
 *  UCs.h
 *
 *     Created on: 25/11/2020
 *         Author: Jorge Matias
 * Student Number: 19011807
 */

#ifndef UC_H_
#define UC_H_

												// Para formatao no cout
#include "NotasUC.h"

class NotasUC;

namespace std{

// *B Constantes para a formatao no cout
const char separador = ' ';  		// Definio do caracter de separao
const int larguraInicial = 8;		// Largura inicial do output
const int larguraCodigo = 15;		// Largura da coluna Cdigo
const int larguraNome = 50;			// Largura da coluna nome
const int larguraOpcaoAv = 18;		// Largura da coluna Opo de Avaliao
const int larguraEfolio = 10;		// Largura da coluna Efolio
const int larguraExame = 12;		// Largura das colunas exames
const int larguraEcts = 10;			// Largura da coluna dos ects
const int larguraNota = 10;			// Largura da coluna da nota
const int larguraFicheiro = 10;		// Largura da coluna Ficheiro
const char linha = '-';				// caracter separador para desenhar ----
const int larguraLinha = 155;		// Largura do Separador horizontal ----

const int precisaoMedia = 3;			// Alterar para redefinir a preciso da media
const int precisaoPercentagemCurso = 1; // Alterar para redefinir a preciso da % conluda do curso

// *B Optei por criar uma nova classe base com as notas da Unidade Curricular, e tornar a Classe UC composta por ela.

class UC : public NotasUC{											// Declarao da classe UC composta por NotaUC
private:															// Seco privada
	unsigned int codigo;											// Cdigo da UC
	string nome;													// Nome da UC
	int ano;														// Ano da UC
	int semestre;													// Semestre da UC
	int ects;														// ECTS da UC
	float nota;														// Nota da UC para estudante especfico
	unsigned int somaAlunosAprovados=0;								// Contador de alunos aprovados
    float somaNotas=0;												// *B Alterei o tipo de somaNotas para Float, penso que faz mais sentido // Valor acumulador que vai receber a soma de todas as notas positivas das UC


public:																// Seco Pblica
	UC();															// Construtor vazio
	UC(string);														// Construtor personalizado que recebe uma string com uma linha de dados
	virtual ~UC();													// Destrutor da Classe UC
	//METODOS
	//Impresso
	void imprimeInfoUC();											// Imprime no ecr a informao de uma UC relativa ao estudante se este obteve aproveitamento
	void imprimeInfoUC(int);										// Imprime no ecr a informao de uma UC relativa ao estudante sem que este tenha obtido aproveitamento
	void imprimeUCcodigoNome();										// Imprime no ecr uma UC com a informao necessria da fase 2 para que o utilizador possa escolher qual o cdigo da UC a inserir
	void imprimeInfoUCcurso();										// Imprime no ecr uma UC com a informao da fase 3 ( enunciado-> nome, alunos aprovados, media total da UC  )

	//Leitura (inline)
	int getCodigo() { return codigo; };								// Devolve o cdigo da UC
	string getNome() { return nome; };								// Devolve o nome da UC
	int getAno() { return ano; };									// Devolve o Ano da UC
	int getsemestre() { return semestre; };							// Devolve o Semestre da UC
	int getEcts() { return ects; };									// Devolve o nmero de ECTS da UC
	int getNota() { return nota; };									// Devolve a nota de um aluno especfico da UC
	int getAlunosAprovados() { return somaAlunosAprovados; };		// Devolve o contador de Alunos aprovados na UC
    float getSomaNotas() { return somaNotas; };						// *B alterao do tipo da funo para float // Devolve a soma total das notas da UC

	// Escrita (inline)
	void setCodigo(int cod) { codigo = cod; };						// Atribui um valor ao cdigo da UC
	void setNome(string n) { nome = n; };							// Atribui o Nome ao nome da UC
	void setAno(int a) { ano = a;};									// Atribui o Ano ao ano da UC
	void setSemestre(int sem) { semestre = sem; };					// Atribui o Semestre ao ano da UC
	void setEcts(int e) { ects = e; };								// Atribui o nmero de ECTS da UC
	void setNota(float nt) { nota = nt; };							// Atribui a nota a nota da UC
	void setAlunoAprovado() { somaAlunosAprovados++; };				// Incrementa o nmero de alunos aprovados
	void setSomaNotas(float grade) { somaNotas = somaNotas + grade; }; // *B Alterado o tipo do argumento // Acumula o valor total de notas em somaNotas

	// Inicializao/Update
	void atualizaNotaFinal();										// * B Atualiza a Nota Final mediante vrias premissas

};

//END namespace
}

#endif /* UC_H_ */
