/*
 *  eFolioB alterado de eFolioA
 *  eFolioB.cpp alterado de eFolioA.cpp
 *
 *     Created on: 24/11/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#include <iostream>
#include <windows.h>																			// Para utilizar SetConsoleOutputCP
#include "Estudantes.h"																			// Header da classe Estudantes
#include "Listacurso.h"																			// Header da classe ListaCurso
#include "UC.h"																					// Header da classe UC composta de NotasUC
#include "Emenu.h"																				// Header da classe Emenu composta de Cmenu
#include "Auxiliar.h"																			// Header das funes auxiliares


using namespace std;

int main (){

	SetConsoleOutputCP(1252);																	// Para definir a opo da code page no terminal do windows de modo a visualizar corretamente os caracteres portugueses

	int alteracoes=0; 																			// flag para se saber se a informao foi alterada
	int nCurso=1;																				// inicializao do inteiro nCurso para receber o cdigo do curso

	Listacurso listaCursosDisponiveis;															// Inicializao da classe ListaCurso que ir "lidar" com o menu dos cursos
	Emenu menuEstudantes;																		// *B Inicializao da classe Emenu para gerir os menus
// *B
	cout << endl <<  "E-flio B - Programao Por Objetos - Aluno Jorge Matias n1901807 " << endl;

	listaCursosDisponiveis.listaFicheiros();													// Cria um vetor com os dados dos cursos existentes na diretoria atual

	while (1){																					// Ciclo infinito at um break;
		cout << endl << "Os cursos atualmente disponveis para serem carregados so:" << endl;			// Informa o utilizador dos cursos que existem atualmente em ficheiros
		listaCursosDisponiveis.imprimeCursosDisponiveis();										// imprime os cursos disponiveis
		cout << "Insira o cdigo do curso que deseja consultar" << endl;						// Pede ao utilizador para inserir o cdigo do curso que pretende escolher
		cout << "Insira 0 para sair" << endl;													// ou 0 para sair
		nCurso = getIntFromUser();																// recebe um inteiro validado do input do utilizador para nCurso
		if (listaCursosDisponiveis.checkCodigoCurso(nCurso))									// verifica se existe esse cdigo de curso
			break;																				// se existir, sai do ciclo
		if (nCurso==0)																			// caso tenha inserido zero
			break;																				// sai do ciclo
		cout << "O curso seleccionado no existe, por favor insira um curso da lista" << endl;  // caso contrario informa que esse cdigo de curso no existe e reinicia o ciclo
	}

	if ( nCurso == 0 ){																			// Caso tenha escolhido zero, sai do programa
		cout <<endl;
		cout << "A Sair ...";
		return 0;																				// com return 0
	}
	cout << "O curso escolhido foi:" << endl;													// seno, informa do curso escolhido
	cout << endl;
	listaCursosDisponiveis.imprimeCursoEscolhido(nCurso);										// imprimindo a informao sobre o mesmo
	cout << endl;
// instaciamento das classes utilizadas
	Listacurso listaUnidadesCurso;
	Listacurso listaEstudantesCurso;

// inicializao de variaveis auxiliares e de manipulao de ficheiros
	string linha;
	string dados;
	stringstream ss;
	string nomefUCs;
	int numUCs=0;																// Contador de UCs
	ifstream fUCs;																// inicializao de fUCs para receber dados de um ficheiro como input

	nomefUCs = to_string(nCurso) + "-UC.txt";									// Inicializa nomefUCs com o nome do ficheiro do curso

	fUCs.open(nomefUCs, ios::in);												// Abre o ficheiro de curso
		if (fUCs.is_open()){													// caso no d erro
			while (getline( fUCs,linha))										// L uma linha at ao fim do ficheiro
				numUCs++;														// incrementa UC
			fUCs.clear();														// limpa fUCs
			fUCs.seekg(0);														// aponta o ficheiro para o inicio
			numUCs--;															// *B Alterao efetuado devido a incluso da linha CURSO no ficheiro de UCs do curso
		cout << "o nmero de UCs do curso : " << numUCs << endl;				// informa do nmero de UCs


		listaUnidadesCurso.setUCsCurso(nCurso, numUCs, fUCs);					// Inicializa o vetor de UCs do curso listaUCsCurso com os dados do ficheiro
		}
	fUCs.close();																// Fecha o ficheiro

	// Abre e conta o nmero de Estudantes o ficheiro dos Estudantes do curso

	string nomefEstudantes;														// String para receber o nome do ficheiro de estudantes
	ifstream fEstudantes;														// Nome da stream de entrada tipo ficheiro

	nomefEstudantes = to_string(nCurso) + "-Estudantes.txt";					// Constri o nome do ficheiro de estudantes, em funo do curso seleccionado

	cout << endl;
	cout << "A abrir o Ficheiro de estudantes " << nomefEstudantes <<endl;
	cout << endl;

	int numEstudantes=0;														// Inicializa o nmero de estudantes
	fEstudantes.open(nomefEstudantes, ios::in);									// Nome do ficheiro dos Estudantes do curso nCurso
	if (fEstudantes.is_open()){													// Confirmao da abertura correta do ficheiro
		while ( getline( fEstudantes,linha) ){									// Enquanto existirem linhas no ficheiro, l para a string linha
			stringstream ss (linha);											// Cria uma stringstream ss a partir da linha lida
			getline (ss,dados,';');												// L uma string (dados) at encontrar um ';'
			if (dados == "ALUNO") {												// Caso a string seja "ALUNO"
				numEstudantes++;												// Incrementa o nmero de alunos
			}
		}
		fEstudantes.clear(); 													// Volta ao incio do ficheiro
		fEstudantes.seekg(0);

		cout << "O nmero de Estudantes carregados  " << numEstudantes << endl;	// Imprime o nmero de estudantes disponveis no ficheiro
		listaEstudantesCurso.setListaEstudantes(nCurso,numEstudantes,fEstudantes); 	// Cria Lista de estudantes atravs de ficheiro

		fEstudantes.close();														// Fecha o ficheiro

		}
	else cout << "No foi possivel abrir o ficheiro " << nomefEstudantes << endl; 	// No caso do ficheiro no ter sido aberto corretamente, Informa o utilizador


	// *B
	cout << endl;
																// *B cria instncia de Emenu (menu Estudantes)
	int opcao=0;																		// Inteiro para receber nmero do aluno
	int codigoUC=0;																		// Inteiro para receber o cdigo da UC

	while(opcao!=9){																			// *B while Geral do Menu Estudantes
		menuEstudantes.imprimeOpcoesGerais();													// *B imprime as opes disponveis no menu estudantes
		opcao = getIntFromUser();																// recebe um inteiro vlido inserido pelo utilizador
		int numAluno=0;																			// inicializa numAluno a zero
		// Menu Geral
		switch(opcao){																			// Para a opo inserida
		case 1:																			// Caso a opo seja 1
			cout << "Escolheu a opo 1 "<< endl << "### CONSULTAR ALUNOS ###" << endl;			// Informa o utilizador da opo efetuada
			while (!listaEstudantesCurso.checkNumAluno(numAluno)){								// Enquanto no se encontrar um nmero de aluno correto faz o ciclo
				menuEstudantes.imprimeEscolhaAluno();											// Pede ao utilizador que insira o nmero de estudante pretendido ou zero para sair
				listaEstudantesCurso.imprimeEstudantesDisponiveis();  							// Imprime os estudantes disponveis na lista
				numAluno = getIntFromUser();													// Recebe o nmero de aluno ( inteiro validado ) do estudante que se pretende consultar

				if (numAluno == 0 )																// Caso o nmero seja zero interrompe a Fase 2, passa a frente
					break;
				if (!listaEstudantesCurso.checkNumAluno(numAluno))								// Caso no seja recebido um nmero de aluno existente
					menuEstudantes.imprimeNumAlunoInvalido();									// Avisa o utilizador e volta ao inicio do ciclo
			}
			listaEstudantesCurso.imprimeInfoEstudantes(numAluno);								// Imprime a informao do estudante escolhido

			break;
		case 2:																			// Caso a opo seja 2
			cout << "Escolheu a opo 2 "<< endl << "### INSERIR NOTAS ###" << endl;

			// Para inserir notas tem que ser selecionado o Estudante e a UC
			// Seleo do Estudante
			while (!listaEstudantesCurso.checkNumAluno(numAluno)){								// Enquanto no se encontrar um nmero de aluno correto faz
				menuEstudantes.imprimeEscolhaAluno();											// Pede ao utilizador que insira o nmero de estudante pretendido ou zero para sair
				listaEstudantesCurso.imprimeEstudantesDisponiveis();  							// Imprime os estudantes disponveis na lista
				numAluno  = getIntFromUser();;													// Recebe o nmero de aluno do estudante que se pretende consultar
				if (numAluno == 0 )																// Caso o nmero seja zero interrompe a Fase 2, passa a frente para a Fase 3
					break;																		// termina o ciclo
				if (!listaEstudantesCurso.checkNumAluno(numAluno))								// Caso no seja recebido um nmero de aluno existente
					menuEstudantes.imprimeNumAlunoInvalido();									// Avisa utilizador de Nmero invlido e reinicia o ciclo
			}
			codigoUC=0;																			// inicializa o cdigo UC a zero

			// Seleo da UC
			while (1){																						// ciclo infinito at um break;
				cout << "Em que Unidade Curricular deseja inserir a nota?" << endl;							// Pergunta ao utilizador em que UC quer inserir notas
				listaUnidadesCurso.imprimeInfoUCs();														// Mostra a informao de todas as UCs do curso
				codigoUC  = getIntFromUser();;																// L do utilizador um inteiro validado
				if(listaUnidadesCurso.checkCodigoUCcurso(codigoUC)){										// caso exista o cdigo do curso
					if (listaEstudantesCurso.checkOpcaoAvaliacaoUCEstudante(numAluno, codigoUC)==-1){		// Verifica se o aluno ainda no tem opo de avaliao definida, se no estiver, informa o utilizador
						cout << "ATENO: O aluno ainda no tem opo de Avaliao definida para esta Unidade Curricular" << endl;
						listaEstudantesCurso.userSetOpcaoAvaliacaoUCEstudante(numAluno, codigoUC);			// Inicia o processo de definio de opo de avaliao
					}
				break;																						// sai do ciclo
				}
				else {																						// Caso contrario informa o utilizador de que o cdigo da UC no existe e reinicia o ciclo
					cout << "No existe nenhuma UC com esse cdigo no sistema, tente novamente "<<  endl;	// at o utilizador inserir um cdigo de UC existente
				}
			}

			// Entra no menu Estudantes -> inserir Notas
			while(opcao){																					// While Menu Inserir Notas, enquanto a opo for diferente de zero faz
				listaEstudantesCurso.imprimeInfoEstudantes(numAluno,codigoUC);								// Imprime a informao da UC do Estudante
				menuEstudantes.imprimeOpcoesInserirNota();													// imprime as Opes disponiveis neste menu inserir nota
				opcao  = getIntFromUser();;																	// recebe um inteiro validado como opcao
				switch(opcao){																				// Para a opcao

				// Caso 1  - Inserir Notas de eFolios
				case 1:
					if ( listaEstudantesCurso.checkOpcaoAvaliacaoUCEstudante(numAluno, codigoUC) == 0){		// Verifica a Opo de Avaliao, se for zero informa o utilizador
						cout << endl <<"ATENO: O aluno optou pela avaliao por Exame Final nesta unidade curricular, logo no  possivel inserir notas de eFolio" << endl;
						opcao = 9;																			// inicializa opcao a 9
						break;																				// Sai do ciclo
					}
					// Se a opo de Avaliao for diferente de zero, ento s pode ser um pois ao entrar no menu inserir notas, a opo de avaliao tem que ficar definida
					while (opcao!=9){																		// Ciclo enquanto a opo for diferente de 9 ou um break;
						menuEstudantes.imprimeOpcoesEfolio();												// Imprime as Opes do menu de Efolios
						opcao  = getIntFromUser();;															// Recebe um inteiro validado como opcao
						switch(opcao){																		// Para opcao
						// Caso 1 Insere nota no eFolio A
						case 1:
							listaEstudantesCurso.userSetNotaEfolioUCEstudante(numAluno, codigoUC,'A');		// chama o mtodo para o utilizador inserir nota e peso no eFolio A
							listaEstudantesCurso.imprimeInfoEstudantes(numAluno,codigoUC);					// imprime a informao
							opcao=0;																		// Inicializa opcao a zero para no voltar a entrar na mesma opcao infinitamente
							break;																			// Sai do switch
						// Caso 2 Insere nota no eFolio B
						case 2:
							listaEstudantesCurso.userSetNotaEfolioUCEstudante(numAluno, codigoUC,'B');		// chama o mtodo para o utilizador inserir nota e peso no eFolio B
							listaEstudantesCurso.imprimeInfoEstudantes(numAluno,codigoUC);					// imprime a informao
							opcao=0;																		// Inicializa opcao a zero para no voltar a entrar na mesma opcao infinitamente
							break;																			// Sai do switch
						// Caso 3 Insere nota no eFolio C
						case 3:
							listaEstudantesCurso.userSetNotaEfolioUCEstudante(numAluno, codigoUC,'C');		// chama o mtodo para o utilizador inserir nota e peso no eFolio C
							listaEstudantesCurso.imprimeInfoEstudantes(numAluno,codigoUC);					// imprime a informao
							opcao=0;																		// Inicializa opcao a zero para no voltar a entrar na mesma opcao infinitamente
							break;																			// Sai do switch
						// Caso 8 Valida valores dos pesos dos eFolios sem sair deste menu
						case 8:
							cout << "A validar os valores inseridos... " << endl;							// Informa o Utilizador
							if(listaEstudantesCurso.validaDadosEfoliosUCEstudantes(numAluno,codigoUC))		// se os dados forem invlidos mostra o que est errado
								break;																		// sai do switch
							break;																			// seno sai do switch na mesma
						// Caso 9 Caso 8 Valida valores dos pesos dos eFolios, se forem vlidos atualiza a nota final e sai para o menu inserir notas
						case 9:
							if(listaEstudantesCurso.validaDadosEfoliosUCEstudantes(numAluno,codigoUC)){	// se os dados forem invlidos mostra o que est errado, se forem vlidos
								listaEstudantesCurso.atualizaNotaFinalUCEstudante(numAluno,codigoUC);		// atualiza a nota final
								alteracoes=1;																// coloca a flag alteracoes a 1 ( h alteraes a gravar )
								cout << "Voltou ao menu #### Inserir Notas ####" << endl;					// Informa o utilizador que voltou a menu Inserir notas
								cout << "Aluno e Unidade Curricular Atualmente Seleccionados" << endl << endl;	// e tambm do aluno e UC atualmente seleccionados
								break;																		// sai do switch
							}
							else opcao=0;																	// seno coloca a opcao a zero para que os dados errados possam ser corrigidos
							break;
						default:																			// Qualquer outro caso  uma opo invalida
							cout << opcao << "  uma opo invlida por favor digite uma opo do menu" << endl;
							opcao=0;																		// coloca opcao a zero
							break;																			// sai do switch eFolios
						}
					}
					break;
				// Caso 2 - Inserir nota de provafinal
				case 2:
					listaEstudantesCurso.userSetNotaProvaFinalUCEstudante(numAluno, codigoUC);				// Chama o Mtodo que permite ao utilizador inserir a nota da prova final ( pFolio ou Exame Final )
					listaEstudantesCurso.atualizaNotaFinalUCEstudante(numAluno,codigoUC);					// Atualiza a Nota Final
					alteracoes=1;																			// Atualiza flag alteracoes para 1
					break;																					// sai do switch
				// Caso 3 - Inserir nota de Exame de Recurso
				case 3:
					listaEstudantesCurso.userSetNotaExameRecursoUCEstudante(numAluno, codigoUC);			// Chama o Mtodo que permite ao utilizador inserir a nota da prova de recurso ( pFolio de recurso ou Exame de Recurso )
					listaEstudantesCurso.atualizaNotaFinalUCEstudante(numAluno,codigoUC);					// Atualiza a Nota Final
					alteracoes=1;																			// Atualiza flag alteracoes para 1
					break;																					// sai do switch
				// Caso 0 - Volta ao menu Estudantes
				case 0:
					break;																					// sai do switch
				default:																					// Qualquer outro caso  uma opo invlida
					cout << opcao << "  uma opo invlida por favor digite uma opo do menu" << endl;	// informa o utilizador
					break;																					// sai do switch
				}
			}
			break;																							// sai do switch inserir nota
		// Caso 3 - inserir Estudante
		case 3:
			cout << "Escolheu a opo 3 "<< endl << "### INSERIR ESTUDANTE ###" << endl;					// informa o utilizador
			listaEstudantesCurso.userSetEstudante(listaUnidadesCurso.getCopiaListaUCsCurso(),listaEstudantesCurso.getCopialistaEstudantes()); // chama o mtodo que permite ao utilizador inserir estudante
			cout <<  "Inseriu o estudante "<< endl;															// Informa o utilizador que inseriu estudante
			alteracoes = 1;																					// altera a flag alteracoes para 1
			break;																							// sai do switch
		// Caso 4  - gravar alteraes no ficheiro
		case 4:
			cout << "Escolheu a opo 4 "<< endl <<"### GRAVAR ALTERAES NO FICHEIRO ###" << endl;			// informa o utilizador da opo escolhida
			if (alteracoes){																				// caso existam alteraes
				listaEstudantesCurso.gravaFicheiro(nomefEstudantes);										// inicia o metodo que grava as informaes dos estudantes para o ficheiro de Estudantes do curso escolhido
				alteracoes = 0;																				// Coloca a flag alteraes a zero pois as alteraes foram gravadas
			}
			else cout << endl << "No foram detetadas alteraes a serem Gravadas..."<< endl;				// caso contrario, informa que no foram detetadas alteraes
			break;																							// sai do switch
		// Caso 9 - Sai do Menu Estudantes e passa para a Fase 3
		case 9:
			break;																							// sai do switch

		default:																							// Qualquer outro caso  uma opo invalida
			cout << opcao << "  uma opo invlida por favor digite uma opo do menu" << endl;			// Informa o utilizador
			break;																							// sai do switch
		}
	}


	opcao = 0;																			// char para opo na Fase 3
	codigoUC=0;																			// inteiro para receber o cdigo da UC

	while(opcao!=9){																	// *B passou de opt != 'x' para opo != 9
	cout << endl;		 // Texto informativo das opes que existem para o utilizador
	cout << "Pretende consultar a informao de todas as UC ou de alguma em particular?" << endl;
	cout << "Para consultar todas pressione '0' para consultar a lista e seleccionar uma UC pressione '1'" << endl; // *B Alteraes nas opes passou de t, c e x para 0,1 e 9 respetivamente
	cout << "Para sair pressione '9'" << endl;
	opcao = getIntFromUser();					// Recebe a opo
	listaUnidadesCurso.setInfoUCsCurso(listaEstudantesCurso.getCopialistaEstudantes()); // Inicializa a lista de UCs do curso com a informao do nmero de alunos e a soma das notas por UC
		switch(opcao) {
			case 0:																// Caso a opo seja 't'
				listaUnidadesCurso.imprimeInfoTodasUCscurso();						// Mostra a informao de todas as UCs do curso
				break;																// sai do switch
			case 1:																// Caso a opo seja 'c'
				cout << endl;
				cout << "Insira o cdigo da UC que Pretende Consultar"<< endl;		// Pergunta qual a UC que o utilizador pretende consultar
				cout << endl;
				listaUnidadesCurso.imprimeInfoUCs();								// Imprime a lista de Ucs disponveis cdigo e nome para o utilizador poder ver o cdigo que pretende
				codigoUC = getIntFromUser();												// Recebe o cdigo da UC pretendida
				if(listaUnidadesCurso.checkCodigoUCcurso(codigoUC))				// caso exista o cdigo do curso
					listaUnidadesCurso.imprimeInfoUCcurso(codigoUC);				// Imprime a UC de curso cujo utilizador escolheu
				else {
					cout << "No existe nenhuma UC com esse cdigo no sistema, tente novamente "<<  endl;
				}

				break;																// Sai do switch
			// *B Caso a opcao seja 9
			case 9:
				if ( alteracoes == 1){
					cout << "ATENO: Existem alteraes por gravar, deseja gravar antes de sair?" << endl;	// Verifica se h alteraes a gravar
					while(1){																				// Ciclo infinito at um break;
						cout << "Para gravar insira 1" << endl;												// Informa o utilizador das opes que tem
						cout << "Para sair sem gravar insira 0" << endl;
						cout << endl;
						opcao = getIntFromUser();															// L um inteiro validado do utilizador
						if (opcao == 1){																	// se for um
							listaEstudantesCurso.gravaFicheiro(nomefEstudantes);							// Grava os dados no ficheiro de Estudante do curso
							opcao=9;																		// coloca a opo a 9
							break;																			// sai do ciclo
						} else if (opcao == 0){																// seno se opo for 0
							opcao = 9;																		// coloca opo a 9
							break;																			// sai do ciclo
						}
						else cout << "A Opo que inseriu  invlida" << endl;								// seno d opo invlida e reinicia o ciclo
					}
				}
				else break;																					// caso contrario sai do switch e do programa
		}
	}
	cout << endl;
	cout << "A sair ..." ;																					// informa que est a sair
	return 0;																								// termina main() com return 0
//END MAIN
}






